/* $Id: auth_misc.c,v 1.1 1998/12/07 20:42:38 fubobb Exp $ */

#include "arpc/auth_misc.h"

char hostname[MAXDNAME+1];
AUTH *auth_root, *auth_nobody;

void
authinit (void)
{
  hostname[sizeof (hostname) - 1] = '\0';
  if (gethostname (hostname, sizeof (hostname)) < 0
      || hostname[sizeof (hostname) - 1])
    fatal ("gethostname: %s\n", strerror (errno));

  /* Make sure we have a fully qualified hostname */
  if (!strchr (hostname, '.')) {
    struct hostent *h = gethostbyname (hostname);
    if (!h)
      fatal ("gethostbyname: `%s' does not exist\n", hostname);
    if (strchr (h->h_name, '.')) {
      hostname[sizeof (hostname) - 1] = '\0';
      strncpy (hostname, h->h_name, sizeof (hostname));
      if (hostname[sizeof (hostname) - 1])
	fatal ("gethostbyname: my name is too long\n");
    }
    else {
      char **cp;
      for (cp = h->h_aliases; cp; cp++)
	if (strchr (*cp, '.')) {
	  hostname[sizeof (hostname) - 1] = '\0';
	  strncpy (hostname, *cp, sizeof (hostname));
	  if (hostname[sizeof (hostname) - 1])
	    fatal ("gethostbyname: my name is too long\n");
	  break;
	}
      if (cp)
	fatal ("can't find a fully qualified hostname for myself");
    }
  }

  auth_root = authunix_create (hostname, 0, 0, 0, NULL);
  assert (auth_root);
  auth_nobody = authunix_create (hostname, -1, -1, 0, NULL);
  assert (auth_nobody);
}

