/* $Id: gencb.c,v 1.1 1998/12/07 20:42:50 fubobb Exp $ */

#include "arpc/misc.h"
#include "arpc/queue.h"

#define GCBHSZ 509

struct gencb {
  LIST_ENTRY (gencb) link;
  void *chan;
  void (*cb) (void *);
  void *arg;
};

LIST_HEAD (gencb_bucket, gencb);

struct gencb_bucket gcbtab[GCBHSZ];

static inline struct gencb_bucket *
bucket (void *chan)
{
  return &gcbtab[(u_long) chan % GCBHSZ];
}

void
gencb_set (void *chan, void (*cb) (void *), void *arg)
{
  struct gencb *gp = xmalloc (sizeof (*gp));
  gp->chan = chan;
  gp->cb = cb;
  gp->arg = arg;
  LIST_INSERT_HEAD (bucket (chan), gp, link);
}

void
gencb_make (void *chan)
{
  struct gencb *gp, *ngp;

  for (gp = bucket (chan)->lh_first; gp; gp = ngp) {
    ngp = gp->link.le_next;
    if (gp->chan == chan) {
      LIST_REMOVE (gp, link);
      gp->cb (gp->arg);
      xfree (gp);
    }
  }
}

void
gencb_makeone (void *chan)
{
  struct gencb *gp;

  for (gp = bucket (chan)->lh_first; gp; gp = gp->link.le_next)
    if (gp->chan == chan) {
      LIST_REMOVE (gp, link);
      gp->cb (gp->arg);
      xfree (gp);
      break;
    }
}

#ifndef NDEBUG
void
gencb_assertnone (void *chan)
{
  struct gencb *gp;

  for (gp = bucket (chan)->lh_first; gp; gp = gp->link.le_next)
    assert (gp->chan != chan);
}
#endif /* !NDEBUG */
