/* $Id: sysconf.h,v 1.1 1998/12/07 20:43:05 fubobb Exp $ */

#ifndef _SFS_SYSCONF_H_
#define _SFS_SYSCONF_H_ 1


#define PORTMAP
#include <config.h>

#ifdef TIME_WITH_SYS_TIME
#include <sys/time.h>
#include <time.h>
#else /* TIME_WITH_SYS_TIME */
#ifdef HAVE_SYS_TIME_H
#include <sys/time.h>
#else /* HAVE_SYS_TIME_H */
#include <time.h>
#endif /* HAVE_SYS_TIME_H */
#endif /* TIME_WITH_SYS_TIME */

#ifdef HAVE_TIMES
#include <sys/times.h>
#endif /* HAVE_TIMES */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <stddef.h>
#include <ctype.h>

#include <limits.h>
#include <unistd.h>

#include <sys/stat.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <sys/uio.h>
#include <sys/param.h>

#ifdef HAVE_GETRUSAGE
#include <sys/resource.h>
#ifdef HAVE_RUSAGE_H
#include <sys/rusage.h>
#endif /* HAVE_RUSAGE_H */
#endif /* HAVE_GETRUSAGE */

#include <assert.h>
#include <errno.h>
#include <fcntl.h>
#include <netdb.h>
#include <pwd.h>
#include <signal.h>

#ifdef HAVE_STRING_H
#include <string.h>
#else /* !HAVE_STRING_H */
#include <strings.h>
#endif /* !HAVE_STRING_H */

#include <netinet/in.h>
#include <arpa/inet.h>
#include <arpa/nameser.h>

#include <rpc/rpc.h>
#include <rpc/pmap_prot.h>
#include <rpc/pmap_clnt.h>
#include <rpc/clnt.h>

#ifndef HAVE_BZERO
#ifdef HAVE_MEMSET
#define bzero(a,b)   memset((a), 0, (b))
#endif
#endif

#ifndef HAVE_STRCHR
#define strchr(a, b)  index((a), (b))
#endif

#ifndef HAVE_U_INT64_T
#if SIZEOF_LONG == 8
#define HAVE_U_INT64_T 1
typedef unsigned long u_int64_t;
#elif SIZEOF_LONG_LONG == 8
#define HAVE_U_INT64_T 1
typedef unsigned long long u_int64_t;
#endif /* !SIZEOF_LONG_LONG */
#endif /* !HAVE_U_INT64_T */

/* Format specifier for printing off_t variables */
#ifdef HAVE_OFF_T_64
#define OTF "q"
#else /* !HAVE_OFF_T_64 */
#define OTF "l"
#endif /* !HAVE_OFF_T_64 */

#if !defined(HAVE_STRERROR) && !defined(strerror)
extern int sys_nerr;
extern char *sys_errlist[];
#define strerror(n) ((unsigned) (n) < sys_nerr \
		     ? sys_errlist[n] : "large error number")
#endif /* !HAVE_STRERROR && !strerror */

#ifndef HAVE_MEMMOVE
#define memmove(d,s,l) bcopy(s,d,l)
#endif /* !HAVE_MEMMOVE */

#ifndef HAVE_INET_ATON
#define inet_aton(a,b)  (((b)->s_addr = inet_addr((a))) != INADDR_NONE)
#endif

#if defined(HAVE_ACCRIGHTS) || defined(HAVE_CMSGHDR)
#define HAVE_FDPASS
#endif /* HAVE_ACCRIGHTS && HAVE_CMSGHDR */

/* FIXME: Solaris 2.4 specific fix */
extern bool_t xdr_callmsg();

#ifdef xdr_authunix_parms
#undef xdr_authunix_parms
#define xdr_authunix_parms xdr_authsys_parms
#endif

#endif /* _SFS_SYSCONF_H_ */
