/* $Id: xdr_suio.c,v 1.1 1998/12/07 20:43:07 fubobb Exp $ */

#include "xdr_suio.h"

static struct xdr_ops xsops = {
    NULL,
    xdrsuio_putlong,
    NULL,
    xdrsuio_putbytes,
    xdrsuio_getpostn,
    NULL,
    xdrsuio_inline,
    xdrsuio_destroy,
};

static const XDR xsproto = {
  XDR_ENCODE, &xsops, NULL, NULL, NULL, 0
};

void
xdrsuio_create (XDR *xdrs, enum xdr_op op)
{
  assert (op == XDR_ENCODE);
  *xdrs = xsproto;
  xsuio (xdrs) = suio_alloc ();
}

void
xdrsuio_destroy (XDR *xdrs)
{
  suio_free (xsuio (xdrs));
}

bool_t
xdr_flatten (xdrproc_t proc, void *objp, char **rdat, u_int *rlen)
{
  XDR x;
  xdrsuio_create (&x, XDR_ENCODE);
  if (!proc (&x, objp)) {
#ifdef DMALLOC
    *rdat = (void *) 0xdeadf1a5;
    *rlen = 0xdeadf1a5;
#endif
    xdrsuio_destroy (&x);
    return FALSE;
  }
  else {
    *rlen = xsuio(&x)->uio_resid;
    *rdat = suio_flatten (xsuio (&x));
    xdrsuio_destroy (&x);
    return TRUE;
  }
}
