/* $Id: xdr_suio.h,v 1.1 1998/12/07 20:43:07 fubobb Exp $ */
/*
 * A Write-only (encode-only) xdr back-end for RPC.  Optimized for
 * large inline chunks.
 */

#include <rpc/rpc.h>
#include <sys/param.h>
#include "sysconf.h"
#include "suio.h"

#define xsuio(x) ((struct suio *) (x)->x_private)

extern void xdrsuio_create (XDR *, enum xdr_op);
extern void xdrsuio_destroy (XDR *);

static inline int32_t *
xdrsuio_inline (XDR *xdrs, u_int count)
{
  register struct suio *const uio = xsuio (xdrs);
  char *space;
  assert (! (count & 3));
  if (count <= SBUFSIZ) {
    space = suio_getspace_aligned (uio, count);
    suio_print (uio, space, count);
  }
  else {
    space = xmalloc (count);
    suio_print (uio, space, count);
    suio_callfree (uio, space);
  }
  assert (!((u_long) space & 0x3));
  return ((int32_t *) space);
}

static inline bool_t
xdrsuio_putlong (XDR *xdrs, long *lp)
{
  *xdrsuio_inline (xdrs, 4) = htonl (*lp);
  return TRUE;
}

static inline bool_t
xdrsuio_putbytes (XDR *xdrs, caddr_t addr, u_int len)
{
  /* assert (! (len & 3)); */
  suio_print (xsuio (xdrs), addr, len);
  return TRUE;
}

static inline u_int
xdrsuio_getpostn (XDR *xdrs)
{
  return (xsuio(xdrs)->uio_resid);
}
