#include <stdio.h>
#include "auth_db.h"
#include "../libdebug/DEBUG.h"


int debuglevel;
char debugf[1024];

int main(int argc, char *argv[]) {

  debuglevel = DEBUG_CONCISE;
  strcpy(debugf,"-");

  if (auth_setup("sampledb.users","sampledb.groups") < 0) {
    perror("auth_setup");
    return(-1);
  }

  return (0);
}


int test_addUser()
{
  
}

/* things to test in the authDB

   auth_setup
   - non existant db file, users and groups
   - poorly formatted files
   - empty files

   auth_addUser
   - add existing user
   - add new user
   - add existing uid
   - new uid
   - add first/last user

   auth_deleteUser
   - delete nonexistant user
   - delete grp owner
   - delete regular
   - delete first/last usr

   auth_user2uid,auth_uid2user,etc.
   - normal use
   - nonexistant args

   auth_addGroup
   - regular use
   - add existing grp
   - add existing gid
   - nonexistant owner
   - add first/last grp
   
   auth_deleteGroup
   - regular
   - delete nonexistant grp
   - delete first/last grp
   
   auth_addGroupMember
   - regular
   - no grp
   - no usr
   - usr all ready in grp
   
   auth_deleteGroupMember
   - regular
   - no grp
   - no usr

   auth_changeGroupOwner
   - regular usage
   - no grp
   - no usr

   */
