/*
 * This is sample code generated by rpcgen.
 * These are only templates and you can use them
 * as a guideline for developing your own functions.
 */

#include "csfsauth_prot.h"
#include <rpc/rpc.h>
#include <stdio.h>
#include "DEBUG.h"
#include "crypto.h"
#include "auth_db.h"
#include <stdlib.h>
#include <rpc/pmap_clnt.h>

auth_database *db;

/* kludge, Include this header from csfsauth_prot_svc.c */
static void
csfsauth_prog_1(struct svc_req *rqstp, register SVCXPRT *transp);


csfsauth_adduserres * 
adduser_1_svc(csfsauth_adduserargs *argp, struct svc_req *rqstp)
{

  static csfsauth_adduserres res;

  DEBUGP(DEBUG_CONCISE, ("csfsauth_adduser_1_svc: Entering\n"));
  /* This is a typical server-side procedure.  Emmulate the
     structure */
  /*
  if (crypto_verify_authen(args->authen,args->body) != 0) {

     DEBUGP(DEBUG_CONCISE,
        ("csfsauth_adduser_1_svc: crypto_verify_authen (%s, %s) failed",
	   args->authen,args->body));
    
  } 

  if (verify_author(args->body->uid,CSFSAUTH_PROG, CSFSAUTH_VERS, ADDUSER)
      != 0) {
    DEBUGP(DEBUG_CONCISE,("csfsauth_adduser_1_svc: verify_author (%d, %d, %d, %d) failed",
	   args->body->uid,CSFSAUTH_PROG, CSFSAUTH_VERS, ADDUSER));

  }

  */


  DEBUGP(DEBUG_CONCISE, ("It works: %d, %s, %d, %s!\n",
			 argp->uid,argp->username, argp->perms, argp->pk.content.content_val));
      

 
  res.status = CSFSAUTH_OK;
  res.csfsauth_adduserres_u.uid =   
    auth_addUser(db, argp->username, argp->uid, argp->perms, argp->pk.content.content_val, argp->pk.content.content_len);
   
  DEBUGP(DEBUG_CONCISE, ("csfsauth_adduser_1_svc: Exitting\n"));

  return ((csfsauth_adduserres *) &res);
}

csfsauth_deluserres * 
deluser_1_svc(csfsauth_deluserargs *argp, struct svc_req *rqstp)
{

	static csfsauth_deluserres  result;

	DEBUGP(DEBUG_CONCISE, ("deluser_1_svc: entering\n"));

	/*
	 * insert server code here
	 */
	if(auth_deleteUser(db, argp->uid))
	  result.status = CSFSAUTH_OK;
	else
	  result.status = CSFSAUTH_NOUSER;

	DEBUGP(DEBUG_CONCISE, ("deluser_1_svc: exiting\n"));

	return(&result);
}

csfsauth_listusersres * 
listusers_1_svc(csfsauth_listusersargs *argp, struct svc_req *rqstp)
{

	static csfsauth_listusersres  result;

	/*
	 * insert server code here
	 */

	return(&result);
}

csfsauth_user2uidres * 
user2uid_1_svc(csfsauth_user2uidargs *argp, struct svc_req *rqstp)
{

	static csfsauth_user2uidres  result;
	int uid;

	DEBUGP(DEBUG_CONCISE,("user2uid_1_svc: entering\n"));
	/*
	 * insert server code here
	 */
	uid = auth_user2uid(db, argp->username);
	if(uid >= 0)
	  {
	    result.status = CSFSAUTH_OK;
	    result.csfsauth_user2uidres_u.uid = uid;
	  }
	else
	  result.status = CSFSAUTH_NOUSER;

	DEBUGP(DEBUG_CONCISE,("user2uid_1_svc: exiting\n"));

	return(&result);
}

csfsauth_uid2userres * 
uid2user_1_svc(csfsauth_uid2userargs *argp, struct svc_req *rqstp)
{

	static csfsauth_uid2userres  result;

	DEBUGP(DEBUG_CONCISE,("uid2user_1_svc: entering\n"));
	/*
	 * insert server code here
	 */

	result.csfsauth_uid2userres_u.username = auth_uid2user(db, argp->uid);
	if(result.csfsauth_uid2userres_u.username == NULL)
	  result.status = CSFSAUTH_NOUID;
	else
	  result.status = CSFSAUTH_OK;

	DEBUGP(DEBUG_CONCISE,("uid2user_1_svc: exiting\n"));
	return(&result);
}

csfsauth_getuserpkres * 
getuserpk_1_svc(csfsauth_getuserpkargs *argp, struct svc_req *rqstp)
{

	static csfsauth_getuserpkres  result;

	DEBUGP(DEBUG_CONCISE,("getuserpk_1_svc: entering\n"));
	/*
	 * insert server code here
	 */

	result.csfsauth_getuserpkres_u.pk.content.content_val = 
	  auth_getUserKey(db, argp->uid, MAX_KEY_LEN);

	result.csfsauth_getuserpkres_u.pk.content.content_len = MAX_KEY_LEN;
  
	DEBUGP(DEBUG_CONCISE,
	       ("getuserpk_1_svc: key = %s\n",
		result.csfsauth_getuserpkres_u.pk.content.content_val));
	if(result.csfsauth_getuserpkres_u.pk.content.content_val == NULL)
	  result.status = CSFSAUTH_NOUID;
	else
	  result.status = CSFSAUTH_OK;
	
	DEBUGP(DEBUG_CONCISE,("getuserpk_1_svc: exiting\n"));
	return(&result);
}

csfsauth_setuserpkres * 
setuserpk_1_svc(csfsauth_setuserpkargs *argp, struct svc_req *rqstp)
{

	static csfsauth_setuserpkres  result;

	DEBUGP(DEBUG_CONCISE,("setuserpk_1_svc: entering\n"));
	/*
	 * insert server code here
	 */
	if(auth_setUserKey(db, argp->uid, argp->pk.content.content_val, argp->pk.content.content_len) >= 0)
	  result.status = CSFSAUTH_OK;
	else
	  result.status = CSFSAUTH_NOUID;

	DEBUGP(DEBUG_CONCISE,("setuserpk_1_svc: exiting\n"));
	return(&result);
}

csfsauth_getuserpermsres * 
getuserperms_1_svc(csfsauth_getuserpermsargs *argp, struct svc_req *rqstp)
{

	static csfsauth_getuserpermsres  result;

	DEBUGP(DEBUG_CONCISE,("getuserperms_1_svc: entering\n"));
	/*
	 * insert server code here
	 */
	if((result.csfsauth_getuserpermsres_u.perms = 
	   auth_getPerms(db, argp->uid)) >= 0)
	  result.status = CSFSAUTH_OK;
	else
	  result.status = CSFSAUTH_NOUID;
	
	DEBUGP(DEBUG_CONCISE,("getuserperms_1_svc: exiting\n"));
	return(&result);
}

csfsauth_setuserpermsres * 
setuserperms_1_svc(csfsauth_setuserpermsargs *argp, struct svc_req *rqstp)
{

	static csfsauth_setuserpermsres  result;

	DEBUGP(DEBUG_CONCISE,("setuserperms_1_svc: entering\n"));

	/*
	 * insert server code here
	 */
	if(auth_setPerms(db, argp->uid, argp->perms) >= 0)
	  result.status = CSFSAUTH_OK;
	else
	  result.status = CSFSAUTH_NOUID;
	
	DEBUGP(DEBUG_CONCISE,("setuserperms_1_svc: exiting\n"));

	return(&result);
}

csfsauth_addgrpres * 
addgrp_1_svc(csfsauth_addgrpargs *argp, struct svc_req *rqstp)
{

	static csfsauth_addgrpres  result;

	DEBUGP(DEBUG_CONCISE,("addgrp_1_svc: entering\n"));

	/*
	 * insert server code here
	 */
	if((result.csfsauth_addgrpres_u.gid = 
	   auth_addGroup(db, argp->grpname, argp->gid, argp->owner)) >= 0)
	  result.status = CSFSAUTH_OK;
	else
	  result.status = CSFSAUTH_NOGRP;

	DEBUGP(DEBUG_CONCISE,("addgrp_1_svc: exiting\n"));
	return(&result);
}

csfsauth_delgrpres * 
delgrp_1_svc(csfsauth_delgrpargs *argp, struct svc_req *rqstp)
{

	static csfsauth_delgrpres  result;

	DEBUGP(DEBUG_CONCISE,("delgrp_1_svc: entering\n"));

	/*
	 * insert server code here
	 */
	if(auth_deleteGroup(db, argp->gid) >= 0)
	  result.status = CSFSAUTH_OK;
	else
	  result.status = CSFSAUTH_NOGRP;

	DEBUGP(DEBUG_CONCISE,("delgrp_1_svc: exiting\n"));

	return(&result);
}

csfsauth_listgrpsres * 
listgrps_1_svc(csfsauth_listgrpsargs *argp, struct svc_req *rqstp)
{

	static csfsauth_listgrpsres  result;

	/*
	 * insert server code here
	 */

	return(&result);
}

csfsauth_grp2gidres * 
grp2gid_1_svc(csfsauth_grp2gidargs *argp, struct svc_req *rqstp)
{

	static csfsauth_grp2gidres  result;

	DEBUGP(DEBUG_CONCISE, ("grp2gid_1_svc: entering\n"));

 	/*
	 * insert server code here
	 */
	
	if((result.csfsauth_grp2gidres_u.gid = 
	    auth_group2gid(db, argp->grpname)) >= 0)
	  result.status = CSFSAUTH_OK;
	else
	  result.status = CSFSAUTH_NOGRP;
	
	DEBUGP(DEBUG_CONCISE, ("grp2gid_1_svc: exiting\n"));

	return(&result);
}

csfsauth_gid2grpres * 
gid2grp_1_svc(csfsauth_gid2grpargs *argp, struct svc_req *rqstp)
{

	static csfsauth_gid2grpres  result;

	DEBUGP(DEBUG_CONCISE, ("gid2grp_1_svc: entering\n"));
	/*
	 * insert server code here
	 */
	if((result.csfsauth_gid2grpres_u.grpname = 
	    auth_gid2group(db, argp->gid)) != NULL)
	  result.status = CSFSAUTH_OK;
	else
	  result.status = CSFSAUTH_NOGID;
	
	DEBUGP(DEBUG_CONCISE, ("gid2grp_1_svc: exiting\n"));

	return(&result);
}

csfsauth_getgrpkeyres * 
getgrpkey_1_svc(csfsauth_getgrpkeyargs *argp, struct svc_req *rqstp)
{

	static csfsauth_getgrpkeyres  result;

	DEBUGP(DEBUG_CONCISE, ("getgrpkey_1_svc: entering\n"));
	/*
	 * insert server code here
	 */
 
	if((result.csfsauth_getgrpkeyres_u.key.content.content_val = auth_getGroupKey(db, argp->gid, argp->uid, MAX_KEY_LEN)) == NULL)
	  result.status = CSFSAUTH_NOGRP;
	else
	  result.status = CSFSAUTH_OK;
	
	result.csfsauth_getgrpkeyres_u.key.content.content_len = MAX_KEY_LEN;

	DEBUGP(DEBUG_CONCISE, ("getgrpkey_1_svc: exiting\n"));
	return(&result);
}

csfsauth_addgrpmemres * 
addgrpmem_1_svc(csfsauth_addgrpmemargs *argp, struct svc_req *rqstp)
{

	static csfsauth_addgrpmemres  result;
	
	DEBUGP(DEBUG_CONCISE, ("addgrpmem_1_svc: entering\n"));
	/*
	 * insert server code here
	 */
	if(auth_addGroupMember(db, argp->gid, argp->uid, argp->pk.content.content_val, argp->pk.content.content_len) >= 0)
	  result.status = CSFSAUTH_OK;
	else
	  result.status = CSFSAUTH_NOUSER;

	DEBUGP(DEBUG_CONCISE, ("addgrpmem_1_svc: exiting\n"));
	return(&result);
}

csfsauth_delgrpmemres * 
delgrpmem_1_svc(csfsauth_delgrpmemargs *argp, struct svc_req *rqstp)
{

	static csfsauth_delgrpmemres  result;

	DEBUGP(DEBUG_CONCISE, ("delgrpmem_1_svc: entering\n"));
	/*
	 * insert server code here
	 */
	if(auth_deleteGroupMember(db, argp->gid, argp->uid) >= 0)
	  result.status = CSFSAUTH_OK;
	else
	  result.status = CSFSAUTH_NOUSER;

	DEBUGP(DEBUG_CONCISE, ("delgrpmem_1_svc: exiting\n"));

	return(&result);
}

csfsauth_listgrpmemsres * 
listgrpmems_1_svc(csfsauth_listgrpmemsargs *argp, struct svc_req *rqstp)
{

	static csfsauth_listgrpmemsres  result;

	/*
	 * insert server code here
	 */

	return(&result);
}

csfsauth_chgrpkeyres * 
chgrpkey_1_svc(csfsauth_chgrpkeyargs *argp, struct svc_req *rqstp)
{

	static csfsauth_chgrpkeyres  result;

	DEBUGP(DEBUG_CONCISE,("chgrpkey_1_svc: entering\n"));
	/*
	 * insert server code here
	 */
	if(auth_changeGroupKey(db, argp->gid, argp->uid, argp->key.content.content_val, argp->key.content.content_len) >= 0)
	  result.status = CSFSAUTH_OK;
	else
	  result.status = CSFSAUTH_NOGRP;

	DEBUGP(DEBUG_CONCISE,("chgrpkey_1_svc: exiting\n"));
	return(&result);
}

csfsauth_chgrpownerres * 
chgrpowner_1_svc(csfsauth_chgrpownerargs *argp, struct svc_req *rqstp)
{

	static csfsauth_chgrpownerres  result;

	DEBUGP(DEBUG_CONCISE, ("chgrpowner_1_svc: entering\n"));
	/*
	 * insert server code here
	 */
	if(auth_changeGroupOwner(db, argp->gid, argp->uid) >= 0)
	  result.status = CSFSAUTH_OK;
	else
	  result.status = CSFSAUTH_NOGRP;

	DEBUGP(DEBUG_CONCISE, ("chgrpowner_1_svc: exiting\n"));
	return(&result);
}
 
csfsauth_getmemgrpsres * 
getmemgrps_1_svc(csfsauth_getmemgrpsargs *argp, struct svc_req *rqstp)
{

	static csfsauth_getmemgrpsres  result;

	/*
	 * insert server code here
	 */

	return(&result);
}



csfsauth_usringrpres *
usringrp_1_svc(csfsauth_usringrpargs *argp, struct svc_req *rqstp)
{

          static csfsauth_usringrpres  result;

	  DEBUGP(DEBUG_CONCISE, ("usringrp_1_svc: entering\n"));
	  /*
	   * insert server code here
	   */

	  if(auth_userInGroup(db, argp->uid, argp->gid) > 0)
	    result.status = CSFSAUTH_OK;
	  else
	    result.status = CSFSAUTH_NOUSER;

	  DEBUGP(DEBUG_CONCISE, ("usringrp_1_svc: exiting\n"));
	  
	  return(&result);
}

int debuglevel;
char debugf[1024];

int
main(int argc, char **argv)
{
        register SVCXPRT *transp;

	debuglevel = DEBUG_CONCISE;
	strcpy(debugf,"-");

        (void) pmap_unset(CSFSAUTH_PROG, CSFSAUTH_VERS);
        transp = svcudp_create(RPC_ANYSOCK);
        if (transp == NULL) {
                fprintf(stderr, "cannot create udp service.");
                exit(1);
        }
        if (!svc_register(transp, CSFSAUTH_PROG, CSFSAUTH_VERS, csfsauth_prog_1, IPPROTO_UDP)) {
                fprintf(stderr, "unable to register (CSFSAUTH_PROG, CSFSAUTH_VERS, udp).");
                exit(1);
        }
        transp = svctcp_create(RPC_ANYSOCK, 0, 0);
        if (transp == NULL) {
                fprintf(stderr, "cannot create tcp service.");
                exit(1);
        }
        if (!svc_register(transp, CSFSAUTH_PROG, CSFSAUTH_VERS, csfsauth_prog_1, IPPROTO_TCP)) {
                fprintf(stderr, "unable to register (CSFSAUTH_PROG, CSFSAUTH_VERS, tcp).");
                exit(1);
        }
	db = auth_setup("users.db", "groups.db");
        svc_run();
	auth_shutdown(db);
        fprintf(stderr, "svc_run returned");
        exit(1);
        /* NOTREACHED */
}
