#include "arpc/arpc.h"
#include "arpc/dns.h"
#include "csfssvc/nfs_prot.h"

#include "sfsclnt.h"
#include "csfscd.h"
#include "sfsvnode.h"
#include "sfsbc.h"

#include "upt/upt.h"


static char buf[512];
struct superblock sb;
struct inode in[2];

int main (int argc, char *argv[])


{
  int  fd, size, idx;
  char *filename = "disk";

  if (argc > 3 || argc < 2) {
    fprintf (stderr, "Usage: mkfs size [filename]\n");
    return (-1);
  }

  size = atoi(argv[1]);

  if (argc == 3) {
    filename = argv[2];
  }
  
  if ((fd = open(filename, O_CREAT | O_TRUNC | O_RDWR, 
	   S_IRWXU | S_IRWXG | S_IRWXO)) < 0) {
    fprintf (stderr, "Could not create %s: %s\n", filename, strerror(errno));
    return (-1);
  }

  /* Create disk */
  for (idx = 0; idx < size; idx++) {
    write (fd, buf, sizeof(buf));
  }
  
  sb.magic = SB_MAGIC;
  sb.nblocks = size;
  sb.bsize = 512;

  lseek(fd, 0, SEEK_SET);

  write (fd, &sb, sizeof(sb));

  bzero(in, sizeof(in));

  in[0].type = NFDIR;
  in[0].inumber = 0;
  in[0].mode = NFSMODE_DIR | 0777;
  in[0].gen  = 0;
  in[0].uid  = 0;
  in[0].gid  = 0;

  lseek (fd, 512, SEEK_SET);
  write (fd, in, sizeof(in));

  close (fd);

  return (0);
}
