#include <stdio.h>
#include <time.h>
#include "rc5.h"

/* Run tests on RC5.  Cross check with rc5ref.c */


void main()
{ WORD i, j, pt1[2], pt2[2], ct[2] = {0,0};
  WORD S[rc5_t];                      /* expanded key table */
  unsigned char key[rc5_b];
  time_t t0, t1;
  if (sizeof(WORD)!=4) 
    printf("RC5 error: WORD has %d bytes.\n",sizeof(WORD));
  printf("RC5-32/12/16 examples:\n");
  for (i=1;i<6;i++)
    { /* Initialize pt1 and key pseudorandomly based on previous ct */
      pt1[0]=ct[0]; pt1[1]=ct[1]; 
      for (j=0;j<rc5_b;j++) key[j] = ct[0]%(255-j);
      /* Setup, encrypt, and decrypt */
      RC5_SETUP(key, S);  
      RC5_ENCRYPT(S,pt1,ct);  
      RC5_DECRYPT(S,ct,pt2);
      /* Print out results, checking for decryption failure */
      printf("\n%d. key = ",i); 
      for (j=0; j<rc5_b; j++) printf("%.2X ",key[j]);
      printf("\n   plaintext %.8lX %.8lX  --->  ciphertext %.8lX %.8lX  \n",
             pt1[0], pt1[1], ct[0], ct[1]);
      if (pt1[0]!=pt2[0] || pt1[1]!=pt2[1]) 
        printf("Decryption Error!");
    }
  time (&t0);
  for (i=1;i<100000;i++)
    RC5_ENCRYPT(S,ct,ct);
  time (&t1);
  printf ("\n   Time_t for 100000 blocks:  %ld \n", t1-t0);
}
