/* Borrowed from dm's SFS */
/* $Id: sha1_aux.c,v 1.1 1999/02/16 18:37:56 fubobb Exp $ */

#include <rpc/rpc.h>
#include "sha1.h"

void
sha1_suio (u_char digest[20], struct suio *uio)
{
  int i;
  sha1_ctx c;

  sha1_init (&c);
  for (i = 0; i < uio->uio_iovcnt; i++)
    sha1_update (&c, uio->uio_iov[i].iov_base, uio->uio_iov[i].iov_len);
  sha1_final (digest, &c);
}

bool_t
xdr_sha1 (u_char hash[20], xdrproc_t proc, void *objp)
{
  XDR x;
  xdrsuio_create (&x, XDR_ENCODE);
  if (!proc (&x, objp)) {
    xdrsuio_destroy (&x);
    return FALSE;
  }
  else {
    sha1_suio (hash, xsuio (&x));
    xdrsuio_destroy (&x);
    return TRUE;
  }
}

#if 0
bool_t
xdr_sha1 (u_char hash[20], xdrproc_t proc, void *objp)
{
  sha1_ctx c;
  char *dat;
  u_int len;

  if (!xdr_flatten (proc, objp, &dat, &len))
    return FALSE;
  sha1_init (&c);
  sha1_update (&c, dat, len);
  sha1_final (hash, &c);
  xfree (dat);
  return TRUE;
}
#endif
