/*
 * Please do not edit this file.
 * It was generated using rpcgen.
 */

#ifndef _CSFSAUTH_PROT_H_RPCGEN
#define _CSFSAUTH_PROT_H_RPCGEN

#include <rpc/rpc.h>

#ifndef AUTH_CSFS
#define AUTH_CSFS 1
#define MAX_USERNAME_LEN 8
#define MAX_GROUPNAME_LEN 8
#define MAX_KEY_LEN 25
#define COOKIE_LEN 2
#define MAX_USERS_PER_GRP 10
#define MAX_GRPS_PER_USER 10

enum csfsauthstat {
	CSFSAUTH_OK = 0,
	CSFSAUTH_NOUSER = 1,
	CSFSAUTH_NOUID = 2,
	CSFSAUTH_NOGRP = 3,
	CSFSAUTH_NOGID = 4,
	CSFSAUTH_NOTIMPL = 5,
	CSFSAUTH_GRP_OWNER = 6,
};
typedef enum csfsauthstat csfsauthstat;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauthstat(XDR *, csfsauthstat*);
#elif __STDC__ 
extern  bool_t xdr_csfsauthstat(XDR *, csfsauthstat*);
#else /* Old Style C */ 
bool_t xdr_csfsauthstat();
#endif /* Old Style C */ 


struct csfsauth_key_t {
	int type;
	struct {
		u_int content_len;
		char *content_val;
	} content;
};
typedef struct csfsauth_key_t csfsauth_key_t;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_key_t(XDR *, csfsauth_key_t*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_key_t(XDR *, csfsauth_key_t*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_key_t();
#endif /* Old Style C */ 


typedef int csfsauth_uid_t;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_uid_t(XDR *, csfsauth_uid_t*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_uid_t(XDR *, csfsauth_uid_t*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_uid_t();
#endif /* Old Style C */ 


typedef int csfsauth_gid_t;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_gid_t(XDR *, csfsauth_gid_t*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_gid_t(XDR *, csfsauth_gid_t*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_gid_t();
#endif /* Old Style C */ 


typedef int csfsauth_gkid_t;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_gkid_t(XDR *, csfsauth_gkid_t*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_gkid_t(XDR *, csfsauth_gkid_t*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_gkid_t();
#endif /* Old Style C */ 


typedef char *csfsauth_user_t;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_user_t(XDR *, csfsauth_user_t*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_user_t(XDR *, csfsauth_user_t*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_user_t();
#endif /* Old Style C */ 


typedef char *csfsauth_grp_t;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_grp_t(XDR *, csfsauth_grp_t*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_grp_t(XDR *, csfsauth_grp_t*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_grp_t();
#endif /* Old Style C */ 


enum csfsauth_perms {
	CSFSAUTH_ADDUSER = 1,
	CSFSAUTH_DELUSER = 2,
	CSFSAUTH_LISTUSERS = 4,
	CSFSAUTH_USER2UID = 8,
	CSFSAUTH_UID2USER = 16,
	CSFSAUTH_GETUSERPK = 32,
	CSFSAUTH_SETUSERPK = 64,
	CSFSAUTH_GETUSERPERMS = 128,
	CSFSAUTH_SETUSERPERMS = 256,
	CSFSAUTH_ADDGRP = 512,
	CSFSAUTH_DELGRP = 1024,
	CSFSAUTH_GRP2GID = 2048,
	CSFSAUTH_GID2GRP = 4096,
	CSFSAUTH_GETGRPKEY = 8192,
	CSFSAUTH_ADDGRPMEM = 16384,
	CSFSAUTH_DELGRPMEM = 32768,
	CSFSAUTH_LISTGRPS = 65536,
	CSFSAUTH_LISTGRPMEMS = 131072,
	CSFSAUTH_CHGRPKEY = 262144,
	CSFSAUTH_CHGRPOWNER = 524288,
	CSFSAUTH_GETMEMGRPS = 1048576,
	CSFSAUTH_ADMIN_PERMS = 0,
	CSFSAUTH_USER_PERMS = 0,
};
typedef enum csfsauth_perms csfsauth_perms;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_perms(XDR *, csfsauth_perms*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_perms(XDR *, csfsauth_perms*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_perms();
#endif /* Old Style C */ 


typedef int csfsauth_perms_t;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_perms_t(XDR *, csfsauth_perms_t*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_perms_t(XDR *, csfsauth_perms_t*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_perms_t();
#endif /* Old Style C */ 


struct csfsauth_adduserargs {
	csfsauth_user_t username;
	csfsauth_uid_t uid;
	csfsauth_key_t pk;
	csfsauth_perms_t perms;
};
typedef struct csfsauth_adduserargs csfsauth_adduserargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_adduserargs(XDR *, csfsauth_adduserargs*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_adduserargs(XDR *, csfsauth_adduserargs*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_adduserargs();
#endif /* Old Style C */ 


struct csfsauth_adduserres {
	csfsauthstat status;
	union {
		csfsauth_uid_t uid;
	} csfsauth_adduserres_u;
};
typedef struct csfsauth_adduserres csfsauth_adduserres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_adduserres(XDR *, csfsauth_adduserres*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_adduserres(XDR *, csfsauth_adduserres*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_adduserres();
#endif /* Old Style C */ 


struct csfsauth_deluserargs {
	csfsauth_uid_t uid;
};
typedef struct csfsauth_deluserargs csfsauth_deluserargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_deluserargs(XDR *, csfsauth_deluserargs*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_deluserargs(XDR *, csfsauth_deluserargs*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_deluserargs();
#endif /* Old Style C */ 


struct csfsauth_deluserres {
	csfsauthstat status;
	union {
	} csfsauth_deluserres_u;
};
typedef struct csfsauth_deluserres csfsauth_deluserres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_deluserres(XDR *, csfsauth_deluserres*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_deluserres(XDR *, csfsauth_deluserres*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_deluserres();
#endif /* Old Style C */ 


struct csfsauth_listusersargs {
	char cookie[COOKIE_LEN];
};
typedef struct csfsauth_listusersargs csfsauth_listusersargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_listusersargs(XDR *, csfsauth_listusersargs*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_listusersargs(XDR *, csfsauth_listusersargs*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_listusersargs();
#endif /* Old Style C */ 


struct csfsauth_listusersokres {
	struct {
		u_int uid_len;
		csfsauth_uid_t *uid_val;
	} uid;
	struct {
		u_int username_len;
		csfsauth_user_t *username_val;
	} username;
	char cookie[COOKIE_LEN];
};
typedef struct csfsauth_listusersokres csfsauth_listusersokres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_listusersokres(XDR *, csfsauth_listusersokres*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_listusersokres(XDR *, csfsauth_listusersokres*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_listusersokres();
#endif /* Old Style C */ 


struct csfsauth_listusersres {
	csfsauthstat status;
	union {
		csfsauth_listusersokres listusersres;
	} csfsauth_listusersres_u;
};
typedef struct csfsauth_listusersres csfsauth_listusersres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_listusersres(XDR *, csfsauth_listusersres*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_listusersres(XDR *, csfsauth_listusersres*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_listusersres();
#endif /* Old Style C */ 


struct csfsauth_user2uidargs {
	csfsauth_user_t username;
};
typedef struct csfsauth_user2uidargs csfsauth_user2uidargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_user2uidargs(XDR *, csfsauth_user2uidargs*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_user2uidargs(XDR *, csfsauth_user2uidargs*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_user2uidargs();
#endif /* Old Style C */ 


struct csfsauth_user2uidres {
	csfsauthstat status;
	union {
		csfsauth_uid_t uid;
	} csfsauth_user2uidres_u;
};
typedef struct csfsauth_user2uidres csfsauth_user2uidres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_user2uidres(XDR *, csfsauth_user2uidres*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_user2uidres(XDR *, csfsauth_user2uidres*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_user2uidres();
#endif /* Old Style C */ 


struct csfsauth_uid2userargs {
	csfsauth_uid_t uid;
};
typedef struct csfsauth_uid2userargs csfsauth_uid2userargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_uid2userargs(XDR *, csfsauth_uid2userargs*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_uid2userargs(XDR *, csfsauth_uid2userargs*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_uid2userargs();
#endif /* Old Style C */ 


struct csfsauth_uid2userres {
	csfsauthstat status;
	union {
		csfsauth_user_t username;
	} csfsauth_uid2userres_u;
};
typedef struct csfsauth_uid2userres csfsauth_uid2userres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_uid2userres(XDR *, csfsauth_uid2userres*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_uid2userres(XDR *, csfsauth_uid2userres*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_uid2userres();
#endif /* Old Style C */ 


struct csfsauth_getuserpkargs {
	csfsauth_uid_t uid;
};
typedef struct csfsauth_getuserpkargs csfsauth_getuserpkargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_getuserpkargs(XDR *, csfsauth_getuserpkargs*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_getuserpkargs(XDR *, csfsauth_getuserpkargs*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_getuserpkargs();
#endif /* Old Style C */ 


struct csfsauth_getuserpkres {
	csfsauthstat status;
	union {
		csfsauth_key_t pk;
	} csfsauth_getuserpkres_u;
};
typedef struct csfsauth_getuserpkres csfsauth_getuserpkres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_getuserpkres(XDR *, csfsauth_getuserpkres*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_getuserpkres(XDR *, csfsauth_getuserpkres*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_getuserpkres();
#endif /* Old Style C */ 


struct csfsauth_setuserpkargs {
	csfsauth_uid_t uid;
	csfsauth_key_t pk;
};
typedef struct csfsauth_setuserpkargs csfsauth_setuserpkargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_setuserpkargs(XDR *, csfsauth_setuserpkargs*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_setuserpkargs(XDR *, csfsauth_setuserpkargs*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_setuserpkargs();
#endif /* Old Style C */ 


struct csfsauth_setuserpkres {
	csfsauthstat status;
	union {
	} csfsauth_setuserpkres_u;
};
typedef struct csfsauth_setuserpkres csfsauth_setuserpkres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_setuserpkres(XDR *, csfsauth_setuserpkres*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_setuserpkres(XDR *, csfsauth_setuserpkres*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_setuserpkres();
#endif /* Old Style C */ 


struct csfsauth_getuserpermsargs {
	csfsauth_uid_t uid;
	csfsauth_perms_t perms;
};
typedef struct csfsauth_getuserpermsargs csfsauth_getuserpermsargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_getuserpermsargs(XDR *, csfsauth_getuserpermsargs*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_getuserpermsargs(XDR *, csfsauth_getuserpermsargs*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_getuserpermsargs();
#endif /* Old Style C */ 


struct csfsauth_getuserpermsres {
	csfsauthstat status;
	union {
		csfsauth_perms_t perms;
	} csfsauth_getuserpermsres_u;
};
typedef struct csfsauth_getuserpermsres csfsauth_getuserpermsres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_getuserpermsres(XDR *, csfsauth_getuserpermsres*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_getuserpermsres(XDR *, csfsauth_getuserpermsres*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_getuserpermsres();
#endif /* Old Style C */ 


struct csfsauth_setuserpermsargs {
	csfsauth_uid_t uid;
	csfsauth_perms_t perms;
};
typedef struct csfsauth_setuserpermsargs csfsauth_setuserpermsargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_setuserpermsargs(XDR *, csfsauth_setuserpermsargs*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_setuserpermsargs(XDR *, csfsauth_setuserpermsargs*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_setuserpermsargs();
#endif /* Old Style C */ 


struct csfsauth_setuserpermsres {
	csfsauthstat status;
	union {
	} csfsauth_setuserpermsres_u;
};
typedef struct csfsauth_setuserpermsres csfsauth_setuserpermsres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_setuserpermsres(XDR *, csfsauth_setuserpermsres*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_setuserpermsres(XDR *, csfsauth_setuserpermsres*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_setuserpermsres();
#endif /* Old Style C */ 


struct csfsauth_addgrpargs {
	csfsauth_grp_t grpname;
	csfsauth_gid_t gid;
	csfsauth_key_t pk;
	csfsauth_uid_t owner;
};
typedef struct csfsauth_addgrpargs csfsauth_addgrpargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_addgrpargs(XDR *, csfsauth_addgrpargs*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_addgrpargs(XDR *, csfsauth_addgrpargs*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_addgrpargs();
#endif /* Old Style C */ 


struct csfsauth_addgrpres {
	csfsauthstat status;
	union {
		csfsauth_gid_t gid;
	} csfsauth_addgrpres_u;
};
typedef struct csfsauth_addgrpres csfsauth_addgrpres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_addgrpres(XDR *, csfsauth_addgrpres*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_addgrpres(XDR *, csfsauth_addgrpres*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_addgrpres();
#endif /* Old Style C */ 


struct csfsauth_delgrpargs {
	csfsauth_gid_t gid;
};
typedef struct csfsauth_delgrpargs csfsauth_delgrpargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_delgrpargs(XDR *, csfsauth_delgrpargs*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_delgrpargs(XDR *, csfsauth_delgrpargs*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_delgrpargs();
#endif /* Old Style C */ 


struct csfsauth_delgrpres {
	csfsauthstat status;
	union {
	} csfsauth_delgrpres_u;
};
typedef struct csfsauth_delgrpres csfsauth_delgrpres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_delgrpres(XDR *, csfsauth_delgrpres*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_delgrpres(XDR *, csfsauth_delgrpres*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_delgrpres();
#endif /* Old Style C */ 


struct csfsauth_listgrpsargs {
	char cookie[COOKIE_LEN];
};
typedef struct csfsauth_listgrpsargs csfsauth_listgrpsargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_listgrpsargs(XDR *, csfsauth_listgrpsargs*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_listgrpsargs(XDR *, csfsauth_listgrpsargs*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_listgrpsargs();
#endif /* Old Style C */ 


struct csfsauth_listgrpsokres {
	struct {
		u_int gid_len;
		csfsauth_gid_t *gid_val;
	} gid;
	struct {
		u_int grpname_len;
		csfsauth_grp_t *grpname_val;
	} grpname;
	char cookie[COOKIE_LEN];
};
typedef struct csfsauth_listgrpsokres csfsauth_listgrpsokres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_listgrpsokres(XDR *, csfsauth_listgrpsokres*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_listgrpsokres(XDR *, csfsauth_listgrpsokres*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_listgrpsokres();
#endif /* Old Style C */ 


struct csfsauth_listgrpsres {
	csfsauthstat status;
	union {
		csfsauth_listgrpsokres listgrpsres;
	} csfsauth_listgrpsres_u;
};
typedef struct csfsauth_listgrpsres csfsauth_listgrpsres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_listgrpsres(XDR *, csfsauth_listgrpsres*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_listgrpsres(XDR *, csfsauth_listgrpsres*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_listgrpsres();
#endif /* Old Style C */ 


struct csfsauth_listgrpmemsargs {
	csfsauth_gid_t gid;
	char cookie[COOKIE_LEN];
};
typedef struct csfsauth_listgrpmemsargs csfsauth_listgrpmemsargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_listgrpmemsargs(XDR *, csfsauth_listgrpmemsargs*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_listgrpmemsargs(XDR *, csfsauth_listgrpmemsargs*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_listgrpmemsargs();
#endif /* Old Style C */ 


struct csfsauth_listgrpmemsokres {
	struct {
		u_int uid_len;
		csfsauth_uid_t *uid_val;
	} uid;
	char cookie[COOKIE_LEN];
};
typedef struct csfsauth_listgrpmemsokres csfsauth_listgrpmemsokres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_listgrpmemsokres(XDR *, csfsauth_listgrpmemsokres*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_listgrpmemsokres(XDR *, csfsauth_listgrpmemsokres*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_listgrpmemsokres();
#endif /* Old Style C */ 


struct csfsauth_listgrpmemsres {
	csfsauthstat status;
	union {
		csfsauth_listgrpmemsokres listgrpmemsres;
	} csfsauth_listgrpmemsres_u;
};
typedef struct csfsauth_listgrpmemsres csfsauth_listgrpmemsres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_listgrpmemsres(XDR *, csfsauth_listgrpmemsres*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_listgrpmemsres(XDR *, csfsauth_listgrpmemsres*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_listgrpmemsres();
#endif /* Old Style C */ 


struct csfsauth_grp2gidargs {
	csfsauth_grp_t grpname;
};
typedef struct csfsauth_grp2gidargs csfsauth_grp2gidargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_grp2gidargs(XDR *, csfsauth_grp2gidargs*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_grp2gidargs(XDR *, csfsauth_grp2gidargs*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_grp2gidargs();
#endif /* Old Style C */ 


struct csfsauth_grp2gidres {
	csfsauthstat status;
	union {
		csfsauth_gid_t gid;
	} csfsauth_grp2gidres_u;
};
typedef struct csfsauth_grp2gidres csfsauth_grp2gidres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_grp2gidres(XDR *, csfsauth_grp2gidres*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_grp2gidres(XDR *, csfsauth_grp2gidres*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_grp2gidres();
#endif /* Old Style C */ 


struct csfsauth_gid2grpargs {
	csfsauth_gid_t gid;
};
typedef struct csfsauth_gid2grpargs csfsauth_gid2grpargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_gid2grpargs(XDR *, csfsauth_gid2grpargs*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_gid2grpargs(XDR *, csfsauth_gid2grpargs*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_gid2grpargs();
#endif /* Old Style C */ 


struct csfsauth_gid2grpres {
	csfsauthstat status;
	union {
		csfsauth_grp_t grpname;
	} csfsauth_gid2grpres_u;
};
typedef struct csfsauth_gid2grpres csfsauth_gid2grpres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_gid2grpres(XDR *, csfsauth_gid2grpres*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_gid2grpres(XDR *, csfsauth_gid2grpres*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_gid2grpres();
#endif /* Old Style C */ 


struct csfsauth_getgrpkeyargs {
	csfsauth_gid_t gid;
	csfsauth_uid_t uid;
};
typedef struct csfsauth_getgrpkeyargs csfsauth_getgrpkeyargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_getgrpkeyargs(XDR *, csfsauth_getgrpkeyargs*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_getgrpkeyargs(XDR *, csfsauth_getgrpkeyargs*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_getgrpkeyargs();
#endif /* Old Style C */ 


struct csfsauth_getgrpkeyres {
	csfsauthstat status;
	union {
		csfsauth_key_t key;
	} csfsauth_getgrpkeyres_u;
};
typedef struct csfsauth_getgrpkeyres csfsauth_getgrpkeyres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_getgrpkeyres(XDR *, csfsauth_getgrpkeyres*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_getgrpkeyres(XDR *, csfsauth_getgrpkeyres*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_getgrpkeyres();
#endif /* Old Style C */ 


struct csfsauth_addgrpmemargs {
	csfsauth_gid_t gid;
	csfsauth_uid_t uid;
	csfsauth_key_t pk;
};
typedef struct csfsauth_addgrpmemargs csfsauth_addgrpmemargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_addgrpmemargs(XDR *, csfsauth_addgrpmemargs*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_addgrpmemargs(XDR *, csfsauth_addgrpmemargs*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_addgrpmemargs();
#endif /* Old Style C */ 


struct csfsauth_addgrpmemres {
	csfsauthstat status;
	union {
	} csfsauth_addgrpmemres_u;
};
typedef struct csfsauth_addgrpmemres csfsauth_addgrpmemres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_addgrpmemres(XDR *, csfsauth_addgrpmemres*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_addgrpmemres(XDR *, csfsauth_addgrpmemres*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_addgrpmemres();
#endif /* Old Style C */ 


struct csfsauth_delgrpmemargs {
	csfsauth_gid_t gid;
	csfsauth_uid_t uid;
};
typedef struct csfsauth_delgrpmemargs csfsauth_delgrpmemargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_delgrpmemargs(XDR *, csfsauth_delgrpmemargs*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_delgrpmemargs(XDR *, csfsauth_delgrpmemargs*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_delgrpmemargs();
#endif /* Old Style C */ 


struct csfsauth_delgrpmemres {
	csfsauthstat status;
	union {
	} csfsauth_delgrpmemres_u;
};
typedef struct csfsauth_delgrpmemres csfsauth_delgrpmemres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_delgrpmemres(XDR *, csfsauth_delgrpmemres*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_delgrpmemres(XDR *, csfsauth_delgrpmemres*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_delgrpmemres();
#endif /* Old Style C */ 


struct csfsauth_chgrpkeyargs {
	csfsauth_gid_t gid;
	csfsauth_uid_t uid;
	csfsauth_key_t key;
};
typedef struct csfsauth_chgrpkeyargs csfsauth_chgrpkeyargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_chgrpkeyargs(XDR *, csfsauth_chgrpkeyargs*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_chgrpkeyargs(XDR *, csfsauth_chgrpkeyargs*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_chgrpkeyargs();
#endif /* Old Style C */ 


struct csfsauth_chgrpkeyres {
	csfsauthstat status;
	union {
	} csfsauth_chgrpkeyres_u;
};
typedef struct csfsauth_chgrpkeyres csfsauth_chgrpkeyres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_chgrpkeyres(XDR *, csfsauth_chgrpkeyres*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_chgrpkeyres(XDR *, csfsauth_chgrpkeyres*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_chgrpkeyres();
#endif /* Old Style C */ 


struct csfsauth_chgrpownerargs {
	csfsauth_gid_t gid;
	csfsauth_uid_t uid;
};
typedef struct csfsauth_chgrpownerargs csfsauth_chgrpownerargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_chgrpownerargs(XDR *, csfsauth_chgrpownerargs*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_chgrpownerargs(XDR *, csfsauth_chgrpownerargs*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_chgrpownerargs();
#endif /* Old Style C */ 


struct csfsauth_chgrpownerres {
	csfsauthstat status;
	union {
	} csfsauth_chgrpownerres_u;
};
typedef struct csfsauth_chgrpownerres csfsauth_chgrpownerres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_chgrpownerres(XDR *, csfsauth_chgrpownerres*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_chgrpownerres(XDR *, csfsauth_chgrpownerres*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_chgrpownerres();
#endif /* Old Style C */ 


struct csfsauth_getmemgrpsargs {
	csfsauth_uid_t uid;
};
typedef struct csfsauth_getmemgrpsargs csfsauth_getmemgrpsargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_getmemgrpsargs(XDR *, csfsauth_getmemgrpsargs*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_getmemgrpsargs(XDR *, csfsauth_getmemgrpsargs*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_getmemgrpsargs();
#endif /* Old Style C */ 


struct csfsauth_getmemgrpsokres {
	struct {
		u_int gid_len;
		csfsauth_gid_t *gid_val;
	} gid;
	struct {
		u_int key_len;
		csfsauth_key_t *key_val;
	} key;
};
typedef struct csfsauth_getmemgrpsokres csfsauth_getmemgrpsokres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_getmemgrpsokres(XDR *, csfsauth_getmemgrpsokres*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_getmemgrpsokres(XDR *, csfsauth_getmemgrpsokres*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_getmemgrpsokres();
#endif /* Old Style C */ 


struct csfsauth_getmemgrpsres {
	csfsauthstat status;
	union {
		csfsauth_getmemgrpsokres getmemgrpsres;
	} csfsauth_getmemgrpsres_u;
};
typedef struct csfsauth_getmemgrpsres csfsauth_getmemgrpsres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_getmemgrpsres(XDR *, csfsauth_getmemgrpsres*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_getmemgrpsres(XDR *, csfsauth_getmemgrpsres*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_getmemgrpsres();
#endif /* Old Style C */ 


struct csfsauth_usringrpargs {
	csfsauth_uid_t uid;
	csfsauth_gid_t gid;
};
typedef struct csfsauth_usringrpargs csfsauth_usringrpargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_usringrpargs(XDR *, csfsauth_usringrpargs*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_usringrpargs(XDR *, csfsauth_usringrpargs*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_usringrpargs();
#endif /* Old Style C */ 


struct csfsauth_usringrpres {
	csfsauthstat status;
	union {
	} csfsauth_usringrpres_u;
};
typedef struct csfsauth_usringrpres csfsauth_usringrpres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfsauth_usringrpres(XDR *, csfsauth_usringrpres*);
#elif __STDC__ 
extern  bool_t xdr_csfsauth_usringrpres(XDR *, csfsauth_usringrpres*);
#else /* Old Style C */ 
bool_t xdr_csfsauth_usringrpres();
#endif /* Old Style C */ 

#endif /* !_CSFSAITH_PROT_H_EXTRA_ */

#define CSFSAUTH_PROG ((u_long)300055)
#define CSFSAUTH_VERS ((u_long)1)

#ifdef __cplusplus
#define ADDUSER ((u_long)1)
extern "C" csfsauth_adduserres * adduser_1(csfsauth_adduserargs *, CLIENT *);
extern "C" csfsauth_adduserres * adduser_1_svc(csfsauth_adduserargs *, struct svc_req *);
#define DELUSER ((u_long)2)
extern "C" csfsauth_deluserres * deluser_1(csfsauth_deluserargs *, CLIENT *);
extern "C" csfsauth_deluserres * deluser_1_svc(csfsauth_deluserargs *, struct svc_req *);
#define LISTUSERS ((u_long)3)
extern "C" csfsauth_listusersres * listusers_1(csfsauth_listusersargs *, CLIENT *);
extern "C" csfsauth_listusersres * listusers_1_svc(csfsauth_listusersargs *, struct svc_req *);
#define USER2UID ((u_long)4)
extern "C" csfsauth_user2uidres * user2uid_1(csfsauth_user2uidargs *, CLIENT *);
extern "C" csfsauth_user2uidres * user2uid_1_svc(csfsauth_user2uidargs *, struct svc_req *);
#define UID2USER ((u_long)5)
extern "C" csfsauth_uid2userres * uid2user_1(csfsauth_uid2userargs *, CLIENT *);
extern "C" csfsauth_uid2userres * uid2user_1_svc(csfsauth_uid2userargs *, struct svc_req *);
#define GETUSERPK ((u_long)6)
extern "C" csfsauth_getuserpkres * getuserpk_1(csfsauth_getuserpkargs *, CLIENT *);
extern "C" csfsauth_getuserpkres * getuserpk_1_svc(csfsauth_getuserpkargs *, struct svc_req *);
#define SETUSERPK ((u_long)7)
extern "C" csfsauth_setuserpkres * setuserpk_1(csfsauth_setuserpkargs *, CLIENT *);
extern "C" csfsauth_setuserpkres * setuserpk_1_svc(csfsauth_setuserpkargs *, struct svc_req *);
#define GETUSERPERMS ((u_long)8)
extern "C" csfsauth_getuserpermsres * getuserperms_1(csfsauth_getuserpermsargs *, CLIENT *);
extern "C" csfsauth_getuserpermsres * getuserperms_1_svc(csfsauth_getuserpermsargs *, struct svc_req *);
#define SETUSERPERMS ((u_long)9)
extern "C" csfsauth_setuserpermsres * setuserperms_1(csfsauth_setuserpermsargs *, CLIENT *);
extern "C" csfsauth_setuserpermsres * setuserperms_1_svc(csfsauth_setuserpermsargs *, struct svc_req *);
#define ADDGRP ((u_long)10)
extern "C" csfsauth_addgrpres * addgrp_1(csfsauth_addgrpargs *, CLIENT *);
extern "C" csfsauth_addgrpres * addgrp_1_svc(csfsauth_addgrpargs *, struct svc_req *);
#define DELGRP ((u_long)11)
extern "C" csfsauth_delgrpres * delgrp_1(csfsauth_delgrpargs *, CLIENT *);
extern "C" csfsauth_delgrpres * delgrp_1_svc(csfsauth_delgrpargs *, struct svc_req *);
#define LISTGRPS ((u_long)12)
extern "C" csfsauth_listgrpsres * listgrps_1(csfsauth_listgrpsargs *, CLIENT *);
extern "C" csfsauth_listgrpsres * listgrps_1_svc(csfsauth_listgrpsargs *, struct svc_req *);
#define GRP2GID ((u_long)13)
extern "C" csfsauth_grp2gidres * grp2gid_1(csfsauth_grp2gidargs *, CLIENT *);
extern "C" csfsauth_grp2gidres * grp2gid_1_svc(csfsauth_grp2gidargs *, struct svc_req *);
#define GID2GRP ((u_long)14)
extern "C" csfsauth_gid2grpres * gid2grp_1(csfsauth_gid2grpargs *, CLIENT *);
extern "C" csfsauth_gid2grpres * gid2grp_1_svc(csfsauth_gid2grpargs *, struct svc_req *);
#define GETGRPKEY ((u_long)15)
extern "C" csfsauth_getgrpkeyres * getgrpkey_1(csfsauth_getgrpkeyargs *, CLIENT *);
extern "C" csfsauth_getgrpkeyres * getgrpkey_1_svc(csfsauth_getgrpkeyargs *, struct svc_req *);
#define ADDGRPMEM ((u_long)16)
extern "C" csfsauth_addgrpmemres * addgrpmem_1(csfsauth_addgrpmemargs *, CLIENT *);
extern "C" csfsauth_addgrpmemres * addgrpmem_1_svc(csfsauth_addgrpmemargs *, struct svc_req *);
#define DELGRPMEM ((u_long)17)
extern "C" csfsauth_delgrpmemres * delgrpmem_1(csfsauth_delgrpmemargs *, CLIENT *);
extern "C" csfsauth_delgrpmemres * delgrpmem_1_svc(csfsauth_delgrpmemargs *, struct svc_req *);
#define LISTGRPMEMS ((u_long)18)
extern "C" csfsauth_listgrpmemsres * listgrpmems_1(csfsauth_listgrpmemsargs *, CLIENT *);
extern "C" csfsauth_listgrpmemsres * listgrpmems_1_svc(csfsauth_listgrpmemsargs *, struct svc_req *);
#define CHGRPKEY ((u_long)19)
extern "C" csfsauth_chgrpkeyres * chgrpkey_1(csfsauth_chgrpkeyargs *, CLIENT *);
extern "C" csfsauth_chgrpkeyres * chgrpkey_1_svc(csfsauth_chgrpkeyargs *, struct svc_req *);
#define CHGRPOWNER ((u_long)20)
extern "C" csfsauth_chgrpownerres * chgrpowner_1(csfsauth_chgrpownerargs *, CLIENT *);
extern "C" csfsauth_chgrpownerres * chgrpowner_1_svc(csfsauth_chgrpownerargs *, struct svc_req *);
#define GETMEMGRPS ((u_long)21)
extern "C" csfsauth_getmemgrpsres * getmemgrps_1(csfsauth_getmemgrpsargs *, CLIENT *);
extern "C" csfsauth_getmemgrpsres * getmemgrps_1_svc(csfsauth_getmemgrpsargs *, struct svc_req *);
#define USRINGRP ((u_long)22)
extern "C" csfsauth_usringrpres * usringrp_1(csfsauth_usringrpargs *, CLIENT *);
extern "C" csfsauth_usringrpres * usringrp_1_svc(csfsauth_usringrpargs *, struct svc_req *);

#elif __STDC__
#define ADDUSER ((u_long)1)
extern  csfsauth_adduserres * adduser_1(csfsauth_adduserargs *, CLIENT *);
extern  csfsauth_adduserres * adduser_1_svc(csfsauth_adduserargs *, struct svc_req *);
#define DELUSER ((u_long)2)
extern  csfsauth_deluserres * deluser_1(csfsauth_deluserargs *, CLIENT *);
extern  csfsauth_deluserres * deluser_1_svc(csfsauth_deluserargs *, struct svc_req *);
#define LISTUSERS ((u_long)3)
extern  csfsauth_listusersres * listusers_1(csfsauth_listusersargs *, CLIENT *);
extern  csfsauth_listusersres * listusers_1_svc(csfsauth_listusersargs *, struct svc_req *);
#define USER2UID ((u_long)4)
extern  csfsauth_user2uidres * user2uid_1(csfsauth_user2uidargs *, CLIENT *);
extern  csfsauth_user2uidres * user2uid_1_svc(csfsauth_user2uidargs *, struct svc_req *);
#define UID2USER ((u_long)5)
extern  csfsauth_uid2userres * uid2user_1(csfsauth_uid2userargs *, CLIENT *);
extern  csfsauth_uid2userres * uid2user_1_svc(csfsauth_uid2userargs *, struct svc_req *);
#define GETUSERPK ((u_long)6)
extern  csfsauth_getuserpkres * getuserpk_1(csfsauth_getuserpkargs *, CLIENT *);
extern  csfsauth_getuserpkres * getuserpk_1_svc(csfsauth_getuserpkargs *, struct svc_req *);
#define SETUSERPK ((u_long)7)
extern  csfsauth_setuserpkres * setuserpk_1(csfsauth_setuserpkargs *, CLIENT *);
extern  csfsauth_setuserpkres * setuserpk_1_svc(csfsauth_setuserpkargs *, struct svc_req *);
#define GETUSERPERMS ((u_long)8)
extern  csfsauth_getuserpermsres * getuserperms_1(csfsauth_getuserpermsargs *, CLIENT *);
extern  csfsauth_getuserpermsres * getuserperms_1_svc(csfsauth_getuserpermsargs *, struct svc_req *);
#define SETUSERPERMS ((u_long)9)
extern  csfsauth_setuserpermsres * setuserperms_1(csfsauth_setuserpermsargs *, CLIENT *);
extern  csfsauth_setuserpermsres * setuserperms_1_svc(csfsauth_setuserpermsargs *, struct svc_req *);
#define ADDGRP ((u_long)10)
extern  csfsauth_addgrpres * addgrp_1(csfsauth_addgrpargs *, CLIENT *);
extern  csfsauth_addgrpres * addgrp_1_svc(csfsauth_addgrpargs *, struct svc_req *);
#define DELGRP ((u_long)11)
extern  csfsauth_delgrpres * delgrp_1(csfsauth_delgrpargs *, CLIENT *);
extern  csfsauth_delgrpres * delgrp_1_svc(csfsauth_delgrpargs *, struct svc_req *);
#define LISTGRPS ((u_long)12)
extern  csfsauth_listgrpsres * listgrps_1(csfsauth_listgrpsargs *, CLIENT *);
extern  csfsauth_listgrpsres * listgrps_1_svc(csfsauth_listgrpsargs *, struct svc_req *);
#define GRP2GID ((u_long)13)
extern  csfsauth_grp2gidres * grp2gid_1(csfsauth_grp2gidargs *, CLIENT *);
extern  csfsauth_grp2gidres * grp2gid_1_svc(csfsauth_grp2gidargs *, struct svc_req *);
#define GID2GRP ((u_long)14)
extern  csfsauth_gid2grpres * gid2grp_1(csfsauth_gid2grpargs *, CLIENT *);
extern  csfsauth_gid2grpres * gid2grp_1_svc(csfsauth_gid2grpargs *, struct svc_req *);
#define GETGRPKEY ((u_long)15)
extern  csfsauth_getgrpkeyres * getgrpkey_1(csfsauth_getgrpkeyargs *, CLIENT *);
extern  csfsauth_getgrpkeyres * getgrpkey_1_svc(csfsauth_getgrpkeyargs *, struct svc_req *);
#define ADDGRPMEM ((u_long)16)
extern  csfsauth_addgrpmemres * addgrpmem_1(csfsauth_addgrpmemargs *, CLIENT *);
extern  csfsauth_addgrpmemres * addgrpmem_1_svc(csfsauth_addgrpmemargs *, struct svc_req *);
#define DELGRPMEM ((u_long)17)
extern  csfsauth_delgrpmemres * delgrpmem_1(csfsauth_delgrpmemargs *, CLIENT *);
extern  csfsauth_delgrpmemres * delgrpmem_1_svc(csfsauth_delgrpmemargs *, struct svc_req *);
#define LISTGRPMEMS ((u_long)18)
extern  csfsauth_listgrpmemsres * listgrpmems_1(csfsauth_listgrpmemsargs *, CLIENT *);
extern  csfsauth_listgrpmemsres * listgrpmems_1_svc(csfsauth_listgrpmemsargs *, struct svc_req *);
#define CHGRPKEY ((u_long)19)
extern  csfsauth_chgrpkeyres * chgrpkey_1(csfsauth_chgrpkeyargs *, CLIENT *);
extern  csfsauth_chgrpkeyres * chgrpkey_1_svc(csfsauth_chgrpkeyargs *, struct svc_req *);
#define CHGRPOWNER ((u_long)20)
extern  csfsauth_chgrpownerres * chgrpowner_1(csfsauth_chgrpownerargs *, CLIENT *);
extern  csfsauth_chgrpownerres * chgrpowner_1_svc(csfsauth_chgrpownerargs *, struct svc_req *);
#define GETMEMGRPS ((u_long)21)
extern  csfsauth_getmemgrpsres * getmemgrps_1(csfsauth_getmemgrpsargs *, CLIENT *);
extern  csfsauth_getmemgrpsres * getmemgrps_1_svc(csfsauth_getmemgrpsargs *, struct svc_req *);
#define USRINGRP ((u_long)22)
extern  csfsauth_usringrpres * usringrp_1(csfsauth_usringrpargs *, CLIENT *);
extern  csfsauth_usringrpres * usringrp_1_svc(csfsauth_usringrpargs *, struct svc_req *);

#else /* Old Style C */ 
#define ADDUSER ((u_long)1)
extern  csfsauth_adduserres * adduser_1();
extern  csfsauth_adduserres * adduser_1_svc();
#define DELUSER ((u_long)2)
extern  csfsauth_deluserres * deluser_1();
extern  csfsauth_deluserres * deluser_1_svc();
#define LISTUSERS ((u_long)3)
extern  csfsauth_listusersres * listusers_1();
extern  csfsauth_listusersres * listusers_1_svc();
#define USER2UID ((u_long)4)
extern  csfsauth_user2uidres * user2uid_1();
extern  csfsauth_user2uidres * user2uid_1_svc();
#define UID2USER ((u_long)5)
extern  csfsauth_uid2userres * uid2user_1();
extern  csfsauth_uid2userres * uid2user_1_svc();
#define GETUSERPK ((u_long)6)
extern  csfsauth_getuserpkres * getuserpk_1();
extern  csfsauth_getuserpkres * getuserpk_1_svc();
#define SETUSERPK ((u_long)7)
extern  csfsauth_setuserpkres * setuserpk_1();
extern  csfsauth_setuserpkres * setuserpk_1_svc();
#define GETUSERPERMS ((u_long)8)
extern  csfsauth_getuserpermsres * getuserperms_1();
extern  csfsauth_getuserpermsres * getuserperms_1_svc();
#define SETUSERPERMS ((u_long)9)
extern  csfsauth_setuserpermsres * setuserperms_1();
extern  csfsauth_setuserpermsres * setuserperms_1_svc();
#define ADDGRP ((u_long)10)
extern  csfsauth_addgrpres * addgrp_1();
extern  csfsauth_addgrpres * addgrp_1_svc();
#define DELGRP ((u_long)11)
extern  csfsauth_delgrpres * delgrp_1();
extern  csfsauth_delgrpres * delgrp_1_svc();
#define LISTGRPS ((u_long)12)
extern  csfsauth_listgrpsres * listgrps_1();
extern  csfsauth_listgrpsres * listgrps_1_svc();
#define GRP2GID ((u_long)13)
extern  csfsauth_grp2gidres * grp2gid_1();
extern  csfsauth_grp2gidres * grp2gid_1_svc();
#define GID2GRP ((u_long)14)
extern  csfsauth_gid2grpres * gid2grp_1();
extern  csfsauth_gid2grpres * gid2grp_1_svc();
#define GETGRPKEY ((u_long)15)
extern  csfsauth_getgrpkeyres * getgrpkey_1();
extern  csfsauth_getgrpkeyres * getgrpkey_1_svc();
#define ADDGRPMEM ((u_long)16)
extern  csfsauth_addgrpmemres * addgrpmem_1();
extern  csfsauth_addgrpmemres * addgrpmem_1_svc();
#define DELGRPMEM ((u_long)17)
extern  csfsauth_delgrpmemres * delgrpmem_1();
extern  csfsauth_delgrpmemres * delgrpmem_1_svc();
#define LISTGRPMEMS ((u_long)18)
extern  csfsauth_listgrpmemsres * listgrpmems_1();
extern  csfsauth_listgrpmemsres * listgrpmems_1_svc();
#define CHGRPKEY ((u_long)19)
extern  csfsauth_chgrpkeyres * chgrpkey_1();
extern  csfsauth_chgrpkeyres * chgrpkey_1_svc();
#define CHGRPOWNER ((u_long)20)
extern  csfsauth_chgrpownerres * chgrpowner_1();
extern  csfsauth_chgrpownerres * chgrpowner_1_svc();
#define GETMEMGRPS ((u_long)21)
extern  csfsauth_getmemgrpsres * getmemgrps_1();
extern  csfsauth_getmemgrpsres * getmemgrps_1_svc();
#define USRINGRP ((u_long)22)
extern  csfsauth_usringrpres * usringrp_1();
extern  csfsauth_usringrpres * usringrp_1_svc();
#endif /* Old Style C */ 

#endif /* !_CSFSAUTH_PROT_H_RPCGEN */
