/*
 * Please do not edit this file.
 * It was generated using rpcgen.
 */

#ifndef _CSFSSD_PROT_H_RPCGEN
#define _CSFSSD_PROT_H_RPCGEN

#include <rpc/rpc.h>

#define CSFSSD_PORT 2049
#define CSFSSD_BLOCK_SIZE 8192
#define CSFSSD_MAXDATA 57344
#define CSFSSD_MAXPATHLEN 1024
#define CSFSSD_MAXNAMLEN 255
#define CSFSSD_MAXCHALLENGE 8
#define CSFSSD_FHSIZE 32
#define CSFSSD_COOKIESIZE 4
#define CSFSSD_FIFO_DEV -1
#define CSFSSD_KEY_LENGTH 16
#define CSFSSD_NUM_META 1
#define CSFSSD_NUM_DIRECT 1
#define CSFSSD_NUM_SINDIRECT 1
#define CSFSSD_NUM_DINDIRECT 1
#define CSFSSD_BLOCK_PTR_SIZE 32
#define CSFSSD_IV_LEN 8
#define CSFSSD_DPTS 3
#define CSFSSD_HASHES 4
#define CSFSSD_INTEGRITY_FIELD_LENGTH 20
#define CSFSSD_MAXDP_REQ 7
#define CSFSSDMODE_FMT 0170000
#define CSFSSDMODE_DIR 0040000
#define CSFSSDMODE_CHR 0020000
#define CSFSSDMODE_BLK 0060000
#define CSFSSDMODE_REG 0100000
#define CSFSSDMODE_LNK 0120000
#define CSFSSDMODE_SOCK 0140000
#define CSFSSDMODE_FIFO 0010000

enum csfssdstat {
	CSFSSD_OK = 0,
	CSFSSDERR_PERM = 1,
	CSFSSDERR_NOENT = 2,
	CSFSSDERR_IO = 5,
	CSFSSDERR_NXIO = 6,
	CSFSSDERR_ACCES = 13,
	CSFSSDERR_EXIST = 17,
	CSFSSDERR_NODEV = 19,
	CSFSSDERR_NOTDIR = 20,
	CSFSSDERR_ISDIR = 21,
	CSFSSDERR_FBIG = 27,
	CSFSSDERR_NOSPC = 28,
	CSFSSDERR_ROFS = 30,
	CSFSSDERR_NAMETOOLONG = 63,
	CSFSSDERR_NOTEMPTY = 66,
	CSFSSDERR_DQUOT = 69,
	CSFSSDERR_STALE = 70,
	CSFSSDERR_WFLUSH = 99,
	CSFSSDERR_LOCK = 100,
};
typedef enum csfssdstat csfssdstat;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfssdstat(XDR *, csfssdstat*);
#elif __STDC__ 
extern  bool_t xdr_csfssdstat(XDR *, csfssdstat*);
#else /* Old Style C */ 
bool_t xdr_csfssdstat();
#endif /* Old Style C */ 


enum csfssd_ftype {
	CSFSSD_NFNON = 0,
	CSFSSD_NFREG = 1,
	CSFSSD_NFDIR = 2,
	CSFSSD_NFBLK = 3,
	CSFSSD_NFCHR = 4,
	CSFSSD_NFLNK = 5,
	CSFSSD_NFSOCK = 6,
	CSFSSD_NFBAD = 7,
	CSFSSD_NFFIFO = 8,
};
typedef enum csfssd_ftype csfssd_ftype;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfssd_ftype(XDR *, csfssd_ftype*);
#elif __STDC__ 
extern  bool_t xdr_csfssd_ftype(XDR *, csfssd_ftype*);
#else /* Old Style C */ 
bool_t xdr_csfssd_ftype();
#endif /* Old Style C */ 


struct csfssd_fh {
	char data[CSFSSD_FHSIZE];
};
typedef struct csfssd_fh csfssd_fh;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfssd_fh(XDR *, csfssd_fh*);
#elif __STDC__ 
extern  bool_t xdr_csfssd_fh(XDR *, csfssd_fh*);
#else /* Old Style C */ 
bool_t xdr_csfssd_fh();
#endif /* Old Style C */ 


typedef char csfssd_hash[CSFSSD_INTEGRITY_FIELD_LENGTH];
#ifdef __cplusplus 
extern "C" bool_t xdr_csfssd_hash(XDR *, csfssd_hash);
#elif __STDC__ 
extern  bool_t xdr_csfssd_hash(XDR *, csfssd_hash);
#else /* Old Style C */ 
bool_t xdr_csfssd_hash();
#endif /* Old Style C */ 


typedef char csfssd_dp_block[CSFSSD_BLOCK_PTR_SIZE];
#ifdef __cplusplus 
extern "C" bool_t xdr_csfssd_dp_block(XDR *, csfssd_dp_block);
#elif __STDC__ 
extern  bool_t xdr_csfssd_dp_block(XDR *, csfssd_dp_block);
#else /* Old Style C */ 
bool_t xdr_csfssd_dp_block();
#endif /* Old Style C */ 


struct csfssd_fattr {
	csfssd_ftype type;
	u_int mode;
	u_long atime;
	u_long mtime;
	u_long ctime;
	u_long dtime;
	u_int uid;
	u_int gid;
	u_long size;
	u_long gkid;
	char owner_lockbox[CSFSSD_KEY_LENGTH];
	char group_lockbox[CSFSSD_KEY_LENGTH];
	char old_owner_lockbox[CSFSSD_KEY_LENGTH];
	char old_group_lockbox[CSFSSD_KEY_LENGTH];
	u_int link_count;
	u_int generation;
	u_long inode_idx;
	csfssd_dp_block block_ptr[CSFSSD_DPTS];
	u_int locked_by;
	u_int locked_duration;
	u_long locked_at;
	u_long magic;
	csfssd_hash block_hash[CSFSSD_HASHES];
	csfssd_hash aicf;
};
typedef struct csfssd_fattr csfssd_fattr;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfssd_fattr(XDR *, csfssd_fattr*);
#elif __STDC__ 
extern  bool_t xdr_csfssd_fattr(XDR *, csfssd_fattr*);
#else /* Old Style C */ 
bool_t xdr_csfssd_fattr();
#endif /* Old Style C */ 


struct csfssd_sattr {
	u_int mode;
	u_int uid;
	u_int gid;
	u_long size;
	u_long atime;
	u_long mtime;
	u_long dtime;
	u_long gkid;
	char owner_lockbox[CSFSSD_KEY_LENGTH];
	char group_lockbox[CSFSSD_KEY_LENGTH];
	csfssd_hash aicf;
};
typedef struct csfssd_sattr csfssd_sattr;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfssd_sattr(XDR *, csfssd_sattr*);
#elif __STDC__ 
extern  bool_t xdr_csfssd_sattr(XDR *, csfssd_sattr*);
#else /* Old Style C */ 
bool_t xdr_csfssd_sattr();
#endif /* Old Style C */ 


struct csfssd_attrstat {
	csfssdstat status;
	union {
		csfssd_fattr attributes;
	} csfssd_attrstat_u;
};
typedef struct csfssd_attrstat csfssd_attrstat;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfssd_attrstat(XDR *, csfssd_attrstat*);
#elif __STDC__ 
extern  bool_t xdr_csfssd_attrstat(XDR *, csfssd_attrstat*);
#else /* Old Style C */ 
bool_t xdr_csfssd_attrstat();
#endif /* Old Style C */ 


struct csfssd_sattrargs {
	csfssd_fh file;
	csfssd_sattr attributes;
};
typedef struct csfssd_sattrargs csfssd_sattrargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfssd_sattrargs(XDR *, csfssd_sattrargs*);
#elif __STDC__ 
extern  bool_t xdr_csfssd_sattrargs(XDR *, csfssd_sattrargs*);
#else /* Old Style C */ 
bool_t xdr_csfssd_sattrargs();
#endif /* Old Style C */ 


struct csfssd_lookupargs {
	u_int inode;
};
typedef struct csfssd_lookupargs csfssd_lookupargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfssd_lookupargs(XDR *, csfssd_lookupargs*);
#elif __STDC__ 
extern  bool_t xdr_csfssd_lookupargs(XDR *, csfssd_lookupargs*);
#else /* Old Style C */ 
bool_t xdr_csfssd_lookupargs();
#endif /* Old Style C */ 


struct csfssd_lookupres {
	csfssdstat status;
	union {
		csfssd_fh file;
	} csfssd_lookupres_u;
};
typedef struct csfssd_lookupres csfssd_lookupres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfssd_lookupres(XDR *, csfssd_lookupres*);
#elif __STDC__ 
extern  bool_t xdr_csfssd_lookupres(XDR *, csfssd_lookupres*);
#else /* Old Style C */ 
bool_t xdr_csfssd_lookupres();
#endif /* Old Style C */ 


struct csfssd_readargs {
	csfssd_fh file;
	u_int offset;
	u_int size;
};
typedef struct csfssd_readargs csfssd_readargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfssd_readargs(XDR *, csfssd_readargs*);
#elif __STDC__ 
extern  bool_t xdr_csfssd_readargs(XDR *, csfssd_readargs*);
#else /* Old Style C */ 
bool_t xdr_csfssd_readargs();
#endif /* Old Style C */ 


struct csfssd_readokres {
	struct {
		u_int data_len;
		char *data_val;
	} data;
};
typedef struct csfssd_readokres csfssd_readokres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfssd_readokres(XDR *, csfssd_readokres*);
#elif __STDC__ 
extern  bool_t xdr_csfssd_readokres(XDR *, csfssd_readokres*);
#else /* Old Style C */ 
bool_t xdr_csfssd_readokres();
#endif /* Old Style C */ 


struct csfssd_readres {
	csfssdstat status;
	union {
		csfssd_readokres reply;
	} csfssd_readres_u;
};
typedef struct csfssd_readres csfssd_readres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfssd_readres(XDR *, csfssd_readres*);
#elif __STDC__ 
extern  bool_t xdr_csfssd_readres(XDR *, csfssd_readres*);
#else /* Old Style C */ 
bool_t xdr_csfssd_readres();
#endif /* Old Style C */ 


struct csfssd_writeargs {
	csfssd_fh file;
	u_int offset;
	u_int size;
	struct {
		u_int data_len;
		char *data_val;
	} data;
};
typedef struct csfssd_writeargs csfssd_writeargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfssd_writeargs(XDR *, csfssd_writeargs*);
#elif __STDC__ 
extern  bool_t xdr_csfssd_writeargs(XDR *, csfssd_writeargs*);
#else /* Old Style C */ 
bool_t xdr_csfssd_writeargs();
#endif /* Old Style C */ 


struct csfssd_lockargs {
	csfssd_fh file;
	u_int uid;
	u_int duration;
};
typedef struct csfssd_lockargs csfssd_lockargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfssd_lockargs(XDR *, csfssd_lockargs*);
#elif __STDC__ 
extern  bool_t xdr_csfssd_lockargs(XDR *, csfssd_lockargs*);
#else /* Old Style C */ 
bool_t xdr_csfssd_lockargs();
#endif /* Old Style C */ 


struct csfssd_lockres {
	csfssdstat status;
	union {
		u_int locked_duration;
		u_int already_locked_duration;
	} csfssd_lockres_u;
};
typedef struct csfssd_lockres csfssd_lockres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfssd_lockres(XDR *, csfssd_lockres*);
#elif __STDC__ 
extern  bool_t xdr_csfssd_lockres(XDR *, csfssd_lockres*);
#else /* Old Style C */ 
bool_t xdr_csfssd_lockres();
#endif /* Old Style C */ 


struct csfssd_unlockargs {
	csfssd_fh file;
	u_int uid;
};
typedef struct csfssd_unlockargs csfssd_unlockargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfssd_unlockargs(XDR *, csfssd_unlockargs*);
#elif __STDC__ 
extern  bool_t xdr_csfssd_unlockargs(XDR *, csfssd_unlockargs*);
#else /* Old Style C */ 
bool_t xdr_csfssd_unlockargs();
#endif /* Old Style C */ 


struct csfssd_readdpargs {
	csfssd_fh file;
	struct {
		u_int dp_nums_len;
		u_int *dp_nums_val;
	} dp_nums;
};
typedef struct csfssd_readdpargs csfssd_readdpargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfssd_readdpargs(XDR *, csfssd_readdpargs*);
#elif __STDC__ 
extern  bool_t xdr_csfssd_readdpargs(XDR *, csfssd_readdpargs*);
#else /* Old Style C */ 
bool_t xdr_csfssd_readdpargs();
#endif /* Old Style C */ 


struct csfssd_readdpres {
	struct {
		u_int dp_len;
		csfssd_dp_block *dp_val;
	} dp;
};
typedef struct csfssd_readdpres csfssd_readdpres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfssd_readdpres(XDR *, csfssd_readdpres*);
#elif __STDC__ 
extern  bool_t xdr_csfssd_readdpres(XDR *, csfssd_readdpres*);
#else /* Old Style C */ 
bool_t xdr_csfssd_readdpres();
#endif /* Old Style C */ 


struct csfssd_writedpargs {
	csfssd_fh file;
	struct {
		u_int dp_nums_len;
		u_int *dp_nums_val;
	} dp_nums;
	struct {
		u_int dp_len;
		csfssd_dp_block *dp_val;
	} dp;
};
typedef struct csfssd_writedpargs csfssd_writedpargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfssd_writedpargs(XDR *, csfssd_writedpargs*);
#elif __STDC__ 
extern  bool_t xdr_csfssd_writedpargs(XDR *, csfssd_writedpargs*);
#else /* Old Style C */ 
bool_t xdr_csfssd_writedpargs();
#endif /* Old Style C */ 


struct csfssd_statfsokres {
	u_int bsize;
	u_int blocks;
	u_int bfree;
	u_int bavail;
};
typedef struct csfssd_statfsokres csfssd_statfsokres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfssd_statfsokres(XDR *, csfssd_statfsokres*);
#elif __STDC__ 
extern  bool_t xdr_csfssd_statfsokres(XDR *, csfssd_statfsokres*);
#else /* Old Style C */ 
bool_t xdr_csfssd_statfsokres();
#endif /* Old Style C */ 


struct csfssd_statfsres {
	csfssdstat status;
	union {
		csfssd_statfsokres reply;
	} csfssd_statfsres_u;
};
typedef struct csfssd_statfsres csfssd_statfsres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfssd_statfsres(XDR *, csfssd_statfsres*);
#elif __STDC__ 
extern  bool_t xdr_csfssd_statfsres(XDR *, csfssd_statfsres*);
#else /* Old Style C */ 
bool_t xdr_csfssd_statfsres();
#endif /* Old Style C */ 


struct csfssd_createargs {
	u_long dir_inode_idx;
};
typedef struct csfssd_createargs csfssd_createargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfssd_createargs(XDR *, csfssd_createargs*);
#elif __STDC__ 
extern  bool_t xdr_csfssd_createargs(XDR *, csfssd_createargs*);
#else /* Old Style C */ 
bool_t xdr_csfssd_createargs();
#endif /* Old Style C */ 


struct csfssd_createres {
	csfssdstat status;
	union {
		u_long inode_idx;
	} csfssd_createres_u;
};
typedef struct csfssd_createres csfssd_createres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfssd_createres(XDR *, csfssd_createres*);
#elif __STDC__ 
extern  bool_t xdr_csfssd_createres(XDR *, csfssd_createres*);
#else /* Old Style C */ 
bool_t xdr_csfssd_createres();
#endif /* Old Style C */ 


struct csfssd_linkargs {
	u_long inode_idx;
};
typedef struct csfssd_linkargs csfssd_linkargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfssd_linkargs(XDR *, csfssd_linkargs*);
#elif __STDC__ 
extern  bool_t xdr_csfssd_linkargs(XDR *, csfssd_linkargs*);
#else /* Old Style C */ 
bool_t xdr_csfssd_linkargs();
#endif /* Old Style C */ 


struct csfssd_linkres {
	csfssdstat status;
	union {
		u_int link_count;
	} csfssd_linkres_u;
};
typedef struct csfssd_linkres csfssd_linkres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfssd_linkres(XDR *, csfssd_linkres*);
#elif __STDC__ 
extern  bool_t xdr_csfssd_linkres(XDR *, csfssd_linkres*);
#else /* Old Style C */ 
bool_t xdr_csfssd_linkres();
#endif /* Old Style C */ 


struct csfssd_unlinkargs {
	u_long inode_idx;
};
typedef struct csfssd_unlinkargs csfssd_unlinkargs;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfssd_unlinkargs(XDR *, csfssd_unlinkargs*);
#elif __STDC__ 
extern  bool_t xdr_csfssd_unlinkargs(XDR *, csfssd_unlinkargs*);
#else /* Old Style C */ 
bool_t xdr_csfssd_unlinkargs();
#endif /* Old Style C */ 


struct csfssd_unlinkres {
	csfssdstat status;
	union {
		u_int link_count;
	} csfssd_unlinkres_u;
};
typedef struct csfssd_unlinkres csfssd_unlinkres;
#ifdef __cplusplus 
extern "C" bool_t xdr_csfssd_unlinkres(XDR *, csfssd_unlinkres*);
#elif __STDC__ 
extern  bool_t xdr_csfssd_unlinkres(XDR *, csfssd_unlinkres*);
#else /* Old Style C */ 
bool_t xdr_csfssd_unlinkres();
#endif /* Old Style C */ 


#define CSFSSD_PROGRAM ((u_long)100004)
#define CSFSSD_VERSION ((u_long)1)

#ifdef __cplusplus
#define CSFSSDPROC_GETATTR ((u_long)1)
extern "C" csfssd_attrstat * csfssdproc_getattr_1(csfssd_fh *, CLIENT *);
extern "C" csfssd_attrstat * csfssdproc_getattr_1_svc(csfssd_fh *, struct svc_req *);
#define CSFSSDPROC_SETATTR ((u_long)2)
extern "C" csfssd_attrstat * csfssdproc_setattr_1(csfssd_sattrargs *, CLIENT *);
extern "C" csfssd_attrstat * csfssdproc_setattr_1_svc(csfssd_sattrargs *, struct svc_req *);
#define CSFSSDPROC_LOOKUP ((u_long)3)
extern "C" csfssd_lookupres * csfssdproc_lookup_1(csfssd_lookupargs *, CLIENT *);
extern "C" csfssd_lookupres * csfssdproc_lookup_1_svc(csfssd_lookupargs *, struct svc_req *);
#define CSFSSDPROC_READ ((u_long)4)
extern "C" csfssd_readres * csfssdproc_read_1(csfssd_readargs *, CLIENT *);
extern "C" csfssd_readres * csfssdproc_read_1_svc(csfssd_readargs *, struct svc_req *);
#define CSFSSDPROC_WRITE ((u_long)5)
extern "C" csfssd_statfsres * csfssdproc_write_1(csfssd_writeargs *, CLIENT *);
extern "C" csfssd_statfsres * csfssdproc_write_1_svc(csfssd_writeargs *, struct svc_req *);
#define CSFSSDPROC_LOCK ((u_long)6)
extern "C" csfssd_lockres * csfssdproc_lock_1(csfssd_lockargs *, CLIENT *);
extern "C" csfssd_lockres * csfssdproc_lock_1_svc(csfssd_lockargs *, struct svc_req *);
#define CSFSSDPROC_UNLOCK ((u_long)7)
extern "C" csfssdstat * csfssdproc_unlock_1(csfssd_unlockargs *, CLIENT *);
extern "C" csfssdstat * csfssdproc_unlock_1_svc(csfssd_unlockargs *, struct svc_req *);
#define CSFSSDPROC_READ_DP_BLOCK ((u_long)8)
extern "C" csfssd_readdpres * csfssdproc_read_dp_block_1(csfssd_readdpargs *, CLIENT *);
extern "C" csfssd_readdpres * csfssdproc_read_dp_block_1_svc(csfssd_readdpargs *, struct svc_req *);
#define CSFSSDPROC_WRITE_DP_BLOCK ((u_long)9)
extern "C" csfssd_statfsres * csfssdproc_write_dp_block_1(csfssd_writedpargs *, CLIENT *);
extern "C" csfssd_statfsres * csfssdproc_write_dp_block_1_svc(csfssd_writedpargs *, struct svc_req *);
#define CSFSSDPROC_STATFS ((u_long)10)
extern "C" csfssd_statfsres * csfssdproc_statfs_1(csfssd_fh *, CLIENT *);
extern "C" csfssd_statfsres * csfssdproc_statfs_1_svc(csfssd_fh *, struct svc_req *);
#define CSFSSDPROC_CREATE ((u_long)11)
extern "C" csfssd_createres * csfssdproc_create_1(csfssd_createargs *, CLIENT *);
extern "C" csfssd_createres * csfssdproc_create_1_svc(csfssd_createargs *, struct svc_req *);
#define CSFSSDPROC_LINK ((u_long)12)
extern "C" csfssd_linkres * csfssdproc_link_1(csfssd_linkargs *, CLIENT *);
extern "C" csfssd_linkres * csfssdproc_link_1_svc(csfssd_linkargs *, struct svc_req *);
#define CSFSSDPROC_UNLINK ((u_long)13)
extern "C" csfssd_unlinkres * csfssdproc_unlink_1(csfssd_unlinkargs *, CLIENT *);
extern "C" csfssd_unlinkres * csfssdproc_unlink_1_svc(csfssd_unlinkargs *, struct svc_req *);

#elif __STDC__
#define CSFSSDPROC_GETATTR ((u_long)1)
extern  csfssd_attrstat * csfssdproc_getattr_1(csfssd_fh *, CLIENT *);
extern  csfssd_attrstat * csfssdproc_getattr_1_svc(csfssd_fh *, struct svc_req *);
#define CSFSSDPROC_SETATTR ((u_long)2)
extern  csfssd_attrstat * csfssdproc_setattr_1(csfssd_sattrargs *, CLIENT *);
extern  csfssd_attrstat * csfssdproc_setattr_1_svc(csfssd_sattrargs *, struct svc_req *);
#define CSFSSDPROC_LOOKUP ((u_long)3)
extern  csfssd_lookupres * csfssdproc_lookup_1(csfssd_lookupargs *, CLIENT *);
extern  csfssd_lookupres * csfssdproc_lookup_1_svc(csfssd_lookupargs *, struct svc_req *);
#define CSFSSDPROC_READ ((u_long)4)
extern  csfssd_readres * csfssdproc_read_1(csfssd_readargs *, CLIENT *);
extern  csfssd_readres * csfssdproc_read_1_svc(csfssd_readargs *, struct svc_req *);
#define CSFSSDPROC_WRITE ((u_long)5)
extern  csfssd_statfsres * csfssdproc_write_1(csfssd_writeargs *, CLIENT *);
extern  csfssd_statfsres * csfssdproc_write_1_svc(csfssd_writeargs *, struct svc_req *);
#define CSFSSDPROC_LOCK ((u_long)6)
extern  csfssd_lockres * csfssdproc_lock_1(csfssd_lockargs *, CLIENT *);
extern  csfssd_lockres * csfssdproc_lock_1_svc(csfssd_lockargs *, struct svc_req *);
#define CSFSSDPROC_UNLOCK ((u_long)7)
extern  csfssdstat * csfssdproc_unlock_1(csfssd_unlockargs *, CLIENT *);
extern  csfssdstat * csfssdproc_unlock_1_svc(csfssd_unlockargs *, struct svc_req *);
#define CSFSSDPROC_READ_DP_BLOCK ((u_long)8)
extern  csfssd_readdpres * csfssdproc_read_dp_block_1(csfssd_readdpargs *, CLIENT *);
extern  csfssd_readdpres * csfssdproc_read_dp_block_1_svc(csfssd_readdpargs *, struct svc_req *);
#define CSFSSDPROC_WRITE_DP_BLOCK ((u_long)9)
extern  csfssd_statfsres * csfssdproc_write_dp_block_1(csfssd_writedpargs *, CLIENT *);
extern  csfssd_statfsres * csfssdproc_write_dp_block_1_svc(csfssd_writedpargs *, struct svc_req *);
#define CSFSSDPROC_STATFS ((u_long)10)
extern  csfssd_statfsres * csfssdproc_statfs_1(csfssd_fh *, CLIENT *);
extern  csfssd_statfsres * csfssdproc_statfs_1_svc(csfssd_fh *, struct svc_req *);
#define CSFSSDPROC_CREATE ((u_long)11)
extern  csfssd_createres * csfssdproc_create_1(csfssd_createargs *, CLIENT *);
extern  csfssd_createres * csfssdproc_create_1_svc(csfssd_createargs *, struct svc_req *);
#define CSFSSDPROC_LINK ((u_long)12)
extern  csfssd_linkres * csfssdproc_link_1(csfssd_linkargs *, CLIENT *);
extern  csfssd_linkres * csfssdproc_link_1_svc(csfssd_linkargs *, struct svc_req *);
#define CSFSSDPROC_UNLINK ((u_long)13)
extern  csfssd_unlinkres * csfssdproc_unlink_1(csfssd_unlinkargs *, CLIENT *);
extern  csfssd_unlinkres * csfssdproc_unlink_1_svc(csfssd_unlinkargs *, struct svc_req *);

#else /* Old Style C */ 
#define CSFSSDPROC_GETATTR ((u_long)1)
extern  csfssd_attrstat * csfssdproc_getattr_1();
extern  csfssd_attrstat * csfssdproc_getattr_1_svc();
#define CSFSSDPROC_SETATTR ((u_long)2)
extern  csfssd_attrstat * csfssdproc_setattr_1();
extern  csfssd_attrstat * csfssdproc_setattr_1_svc();
#define CSFSSDPROC_LOOKUP ((u_long)3)
extern  csfssd_lookupres * csfssdproc_lookup_1();
extern  csfssd_lookupres * csfssdproc_lookup_1_svc();
#define CSFSSDPROC_READ ((u_long)4)
extern  csfssd_readres * csfssdproc_read_1();
extern  csfssd_readres * csfssdproc_read_1_svc();
#define CSFSSDPROC_WRITE ((u_long)5)
extern  csfssd_statfsres * csfssdproc_write_1();
extern  csfssd_statfsres * csfssdproc_write_1_svc();
#define CSFSSDPROC_LOCK ((u_long)6)
extern  csfssd_lockres * csfssdproc_lock_1();
extern  csfssd_lockres * csfssdproc_lock_1_svc();
#define CSFSSDPROC_UNLOCK ((u_long)7)
extern  csfssdstat * csfssdproc_unlock_1();
extern  csfssdstat * csfssdproc_unlock_1_svc();
#define CSFSSDPROC_READ_DP_BLOCK ((u_long)8)
extern  csfssd_readdpres * csfssdproc_read_dp_block_1();
extern  csfssd_readdpres * csfssdproc_read_dp_block_1_svc();
#define CSFSSDPROC_WRITE_DP_BLOCK ((u_long)9)
extern  csfssd_statfsres * csfssdproc_write_dp_block_1();
extern  csfssd_statfsres * csfssdproc_write_dp_block_1_svc();
#define CSFSSDPROC_STATFS ((u_long)10)
extern  csfssd_statfsres * csfssdproc_statfs_1();
extern  csfssd_statfsres * csfssdproc_statfs_1_svc();
#define CSFSSDPROC_CREATE ((u_long)11)
extern  csfssd_createres * csfssdproc_create_1();
extern  csfssd_createres * csfssdproc_create_1_svc();
#define CSFSSDPROC_LINK ((u_long)12)
extern  csfssd_linkres * csfssdproc_link_1();
extern  csfssd_linkres * csfssdproc_link_1_svc();
#define CSFSSDPROC_UNLINK ((u_long)13)
extern  csfssd_unlinkres * csfssdproc_unlink_1();
extern  csfssd_unlinkres * csfssdproc_unlink_1_svc();
#endif /* Old Style C */ 

#endif /* !_CSFSSD_PROT_H_RPCGEN */
