/* Portions borrowed from Pat McCormick <pmccormi@mit.edu>
**
** $Id: DEBUG.c,v 1.2 1998/11/16 01:53:45 fubobb Exp $ 
**
*/

#include <stdlib.h>
#include <stdio.h>
#ifdef __STDC__
#include <stdarg.h>
#else
#include <varargs.h>
#endif
#include <sys/stat.h>

#define DEFAULT_DEBUGLEVEL 0

/** Modified from the Samba source code **/

int debuglevel = DEFAULT_DEBUGLEVEL;
char debugf[1024] = "-";
FILE *dbf = NULL;

/** 
 * _DEBUG - function to print debug messages.
 *
 * Write an debug message on the debugfile. This is called by the DEBUGP
 * macro. Returns 0.
 *
 **/
#ifdef __STDC__
int _DEBUG(char *format_str, ...)
{
#else
int _DEBUG(va_dcl va_alist)
{ 
    char *format_str;
#endif
    va_list ap;

    if (debuglevel == 0) return 0;
   
    if (debugf[0] == '-') {
	dbf = stdout;
    }
  
    if (!dbf) {
	int oldumask = umask(022);
	dbf = fopen(debugf,"w");
	umask(oldumask);
	if (dbf)
	    setbuf(dbf,NULL);
	else
	    return(0);
    }
    
#ifdef __STDC__
    va_start(ap, format_str);
#else
    va_start(ap);
    format_str = va_arg(ap,char *);
#endif
    vfprintf(dbf,format_str,ap);
    va_end(ap);
    fflush(dbf);

    return(0);
}
