/* Portions borrowed from Pat McCormick <pmccormi@mit.edu>
**
** $Id: DEBUG.h,v 1.5 1999/03/25 03:44:27 fubob Exp $ 
**
** $Log: DEBUG.h,v $
** Revision 1.5  1999/03/25 03:44:27  fubob
** fixed define scope
**
** Revision 1.4  1999/03/11 01:51:31  fubobb
** note on usage.  Each program needs to set "debuglevel" and "debugf".
**
** debuglevel is an integer.  Set it to DEBUG_CONCISE or DEBUG_VERBOSE
**
** debugf is a filename.  Do not set it if you want debugging info to
** reach stderr.  Otherwise set debugf  = "afilename";
**
** Revision 1.3  1999/03/11 01:49:04  fubobb
** Defines:
**
** DEBUG_CONCISE (print only when needing a few debugging stmts)
** DEBUG_VERBOSE (print only if we want verbose debugging info)
**
** Revision 1.2  1998/11/16 01:53:48  fubobb
** Help, I've fallen and I can't get up!  libdebug to the rescue.
**
** 
*/

#ifndef _DEBUG_HEADER
#define _DEBUG_HEADER

#define DEBUG_CONCISE   1
#define DEBUG_VERBOSE   15

#ifdef DEBUG

#define DEBUG_FILL 0xCC


extern int debuglevel;
extern char debugf[1024];

#ifdef __cplusplus
extern "C" {
#endif

#ifdef __STDC__
int _DEBUG(char *format_str, ...);
#else
int _DEBUG(va_dcl va_alist);
#endif

#ifdef __cplusplus
}
#endif

#define DEBUGP(level,body) ((debuglevel>=(level))?(_DEBUG body):0)

#else /* if not DEBUG */

#define DEBUGP(level,body)

#endif

#endif /* _DEBUG_HEADER */
