/* UNIX domain sockets 4.3+BSD */

#ifndef __IPC_HEADER__
#define __IPC_HEADER__


#define CLI_PATH "/var/tmp/csfs_uagent"  /* +5 for pid = 14 chars */
#define CSFSCD_PATH "/var/tmp/csfs_cd" /* CD's well-known name */

#define CLI_PERM S_IRWXU      /* rwx for user only */

#define STALE 30             /* client's name can't be older than this (sec) 
				Yes, this allows for a TOCTOCTU attack */

/* Given: A path to a file
 * Returns: If ok, a file descriptor to listen on.  Else <0 on error 
 */
int serv_listen (const char *name);

/* Given: Listen fd 
 * Returns: New file descriptor if ok and puts Eff. UID in uidptr.
 *          Else <0 on error.
 */
int serv_accept (int listenfd, uid_t *uidptr);


/* Given: Path to server's named pipe
 * Returns: File descriptor if ok.  Else <0 on error.
 */
int cli_conn(const char *name);

#endif
