/* $Id: nfsconf.h,v 1.1 1998/12/07 20:42:25 fubobb Exp $ */

#ifndef _NFSCONF_H_
#define _NFSCONF_H_ 1

/*
 * system-specific NFS mount stuff
 */

#ifdef __FreeBSD__
#define NFS 1
#endif /* __FreeBSD__ */

#ifdef __sun__
#define NFSCLIENT 1
#endif /* __SunOS__ */

#include <sys/types.h>
#include <sys/param.h>
#include <sys/mount.h>
#if NEED_NFS_NFS_H
#include <nfs/nfs.h>
#endif /* NEED_NFS_NFS_H */
#if NEED_NFS_MOUNT_H
#include <nfs/mount.h>
#endif /* NEED_NFS_MOUNT_H */

#if __linux__
# ifndef __GLIBC__
#  include <linux/fs.h> /* patch up broken pieces */
# endif
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <rpc/rpc.h> /* linux libc5 is *broken*! */

#include <rpcsvc/nfs_prot.h> /*linux libc5 does not #ifdef bracket this code*/
#ifndef _NFS_PROT_H_RPCGEN
#define _NFS_PROT_H_RPCGEN
#endif
#include <linux/nfs_mount.h> /* can't help but include this one. */
#define nfs_args nfs_mount_data
#define NFS_ARGSVERSION NFS_MOUNT_VERSION
#endif /* __linux__ */

#if defined(__ultrix)
/* This doesn't work yet! */
#include <sys/fs_types.h>
#include <nfs/nfs_gfs.h>
#define nfs_args nfs_gfs_mount
#define MOUNT_NFS GT_NFS
#endif /* __ultrix */

#ifndef MOUNT_NFS
#define MOUNT_NFS "nfs"
#endif /* !MOUNT_NFS */

#ifndef MNT_NOSUID
#if defined (M_NOSUID)
#define MNT_NOSUID M_NOSUID
#elif defined (MS_NOSUID)
#define MNT_NOSUID MS_NOSUID
#else /* no MNT_NOSUID substitute found */
#define NO_NOSUID 1
#define MNT_NOSUID 0
#endif /* no MNT_NOSUID substitute found */
#endif /* !MNT_NOSUID */

#ifndef MNT_NODEV
#if defined (M_NODEV)
#define MNT_NODEV M_NODEV
#elif defined (MS_NODEV)
#define MNT_NODEV MS_NODEV
#else /* no nodev mount flag */
#define MNT_NODEV 0
#ifndef NFSMNT_NODEV
#define NO_NODEVS 1
#endif /* !NFSMNT_NODEV */
#endif /* nnodev mount flag */
#endif /* !MNT_NODEV */

#ifndef MNT_RDONLY
#if defined (M_RDONLY)
#define MNT_RDONLY M_RDONLY
#elif defined (MS_RDONLY)
#define MNT_RDONLY MS_RDONLY
#else /* no MNT_RDONLY substitute found */
#define MNT_RDONLY 0
#endif /* no MNT_RDONLY substitute found */
#endif /* !MNT_RDONLY */

#if defined(__linux__)

#define SYS_NFS_MOUNT(dir, mntflags, args) \
    mount ((args)->hostname, dir, MOUNT_NFS, MS_MGC_VAL | mntflags, args)

#elif defined(__ultrix)
/* This doesn't work yet! */
#define SYS_NFS_MOUNT(dir, mntflags, args) \
    mount ((args)->hostname, dir, mntflags, MOUNT_NFS, args)

#elif defined(MS_DATA) /* SVR4 6 argument mount */
#define SVR4MNT 1


#define SYS_NFS_MOUNT(dir, mntflags, args)			\
    mount ((args)->hostname, dir, MS_DATA|mntflags, MOUNT_NFS,	\
	   args, sizeof (*(args)))

#elif M_NEWTYPE /* SunOS 4 */
#define SYS_NFS_MOUNT(dir, mntflags, args) \
    mount (MOUNT_NFS, dir, M_NEWTYPE|mntflags, args)

#elif HAVE_VFSMOUNT /* HPUX9 */
#define SYS_NFS_MOUNT(dir, mntflags, args) \
    vfsmount (MOUNT_NFS, dir, mntflags, args)

#else /* normal mount syscall */
#define SYS_NFS_MOUNT(dir, mntflags, args) \
    mount (MOUNT_NFS, dir, mntflags, args)

#endif /* normal mount syscall */

#ifndef HAVE_UNMOUNT
#define unmount umount
#endif /* !HAVE_UNMOUNT */

#endif /* _NFSCONF_H_ */
