/* $Id: disk_test.c,v 1.1 1998/11/20 03:47:13 fubobb Exp $*/

/* $Log: disk_test.c,v $
 * Revision 1.1  1998/11/20 03:47:13  fubobb
 * server daemon code.
 * sine RPC et suffragio.
 **/

#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>

#include <sys/time.h>
#include <sys/types.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include "disk.h"
#include "libdebug/DEBUG.h"
#include "libdebug/ASSERT.h"

#define TEST_MAX_LEN 30

void main(int argc, char *argv[])
{
  int disk,j;
  char filename[TEST_MAX_LEN];
  char block[BLOCK_SIZE];
  unsigned int blocks,i,num,checksum,checksum2;

  debuglevel = 11;

  printf ("Open disk filename: ");
  scanf("%s",filename);

  printf ("Disk size [0 -> (2^%d)-1]: ",8*sizeof(unsigned int));
  scanf("%du",&blocks);

  printf ("Opening disk %s, blocks %u, size %lu kb\n",
	  filename,blocks,(unsigned long)(blocks*BLOCK_SIZE/1024));

  disk=openDisk(filename,blocks);
  ASSERT(disk>=0);

  printf ("Writing over all blocks.\n");

  /* Put random data on disk.  Verify checksum */
  checksum=0;
  srand((int) time((long *) 0));
  for (i=0; i<blocks; i++) {
    memset(block,0,BLOCK_SIZE);
    for (j=0; j<=BLOCK_SIZE/sizeof(unsigned int)-1; j++) {
      num=rand();
      checksum^=num;
      memcpy((char *) (block+(j*sizeof(unsigned int))),
	     &num,sizeof(unsigned int));
    }
    ASSERT (writeBlock(disk,i,(void *)block)==0);
    /*    printf("Wrote block %lu\n",i);*/
  }
  
  printf ("Writing checksum: %d\n",checksum);
  printf ("Reading disk, verifying checksum\n");

  checksum2=0;
  for (i=0; i<blocks; i++) {
    ASSERT (readBlock(disk,i,(void *)block)==0);
    /*    printf("Read block %lu\n",i);*/

    for (j=0; j<=BLOCK_SIZE/sizeof(unsigned int)-1; j++) {
      memcpy(&num,(char *)(block+(j*sizeof(unsigned int))),
	     sizeof(unsigned int));
      checksum2^=num;
    }
  }
  printf ("Write checksum %d  Read checksum: %d\n",checksum,checksum2);
  ASSERT(checksum==checksum2);
  syncDisk(disk); 

  printf ("Attempting to sync bad disk numbers\n");
  syncDisk(-1);
  syncDisk(disk+1);

  printf ("Attempting to reopen disk.\n");
  disk=openDisk(filename,blocks);
  ASSERT(disk>=0);

  memset(block,0,BLOCK_SIZE);
  printf ("Attempting to write bad block nums.\n");
  ASSERT(writeBlock(disk,blocks,block)<0);
  ASSERT(writeBlock(disk,blocks+1,block)<0);

  printf ("Attempting to read bad block nums.\n");
  ASSERT(readBlock(disk,blocks,block)<0);
  ASSERT(readBlock(disk,blocks+1,block)<0);

}

