#include <rpc/rpc.h>
#include <stdio.h>
#include <string.h>
#include <sys/stat.h>

#include "csfssd_prot.h"
#include "csfssd.h"
#include "csfsauth_prot.h" 
#include "DEBUG.h"
#include "ASSERT.h"
#include "misc/types.h"


u32 fh2inode_idx(csfssd_fh fh) {
  u32 inode_idx;
  memcpy(&inode_idx, fh.data, 4);

  return (inode_idx);
}

/* Load a disk if not already loaded */
int newdisk(csfssd_t **csfssd) {
  char *filename = strdup("/tmp/disk");

  if (*csfssd != NULL) {
    return -1;
  }

  if (CSFSSD_mount(*csfssd, filename, 0) < 0)
    { return -2; }

  return 0;
}

int sd_userInGroup(uid, gid)
{
  CLIENT *authcl;
  csfsauth_usringrpargs args;
  csfsauth_usringrpres *result;

  if(!(authcl = clnt_create("127.0.0.1", CSFSAUTH_PROG, CSFSAUTH_VERS, "tcp")))
    {
      clnt_pcreateerror("127.0.0.1");
      exit(1);
    }

  bzero(&args, sizeof(csfsauth_usringrpargs));
  args.uid = uid;
  args.gid = gid;

  result = usringrp_1(&args, authcl);

  if(results->status == CSFSAUTH_OK)
    return 1;

  return 0;
}
