/*
 * This is sample code generated by rpcgen.
 * These are only templates and you can use them
 * as a guideline for developing your own functions.
 */


#include "csfssd_prot.h"
#include "csfssd.h"
#include "DEBUG.h"
#include "ASSERT.h"
#include <string.h>

csfssd_t *csfssd = NULL;

/* from csfssd_prot_svc.c */
static void 
csfssd_program_1(struct svc_req *rqstp, register SVCXPRT *transp);

csfssd_attrstat * 
csfssdproc_getattr_1_svc(csfssd_fh *argp, struct svc_req *rqstp)
{
  static csfssd_attrstat  result;
  inode_t *file;

  DEBUGP(DEBUG_CONCISE, ("csfssdproc_getattr_1_svc: entering\n"));
  /*
   * insert server code here
   */

  file = malloc(sizeof(inode_t));

  /* lookup inode */

  if(CSFSSD_readInode(csfssd, file, ((csfssd_fh_t*)(argp))->inode) < 0) 
    {
      DEBUGP(DEBUG_CONCISE,
	     ("csfssdproc_getattr_1_svc: can't read inode. exiting\n"));
      result.status = CSFSSDERR_NOENT;
      return(&result);
    }
 
  /* look this over many times. It is probably wrong */

  memcpy(&(result.csfssd_attrstat_u.attributes.type), 
	 &(file->mode), sizeof(csfssd_ftype));
  result.csfssd_attrstat_u.attributes.mode = file->mode;
  memcpy(&(result.csfssd_attrstat_u.attributes.atime),
	 &(file->atime), sizeof(u32));
  memcpy(&(result.csfssd_attrstat_u.attributes.mtime),
	 &(file->mtime), sizeof(u32));
  memcpy(&(result.csfssd_attrstat_u.attributes.ctime),
	 &(file->ctime), sizeof(u32));
  memcpy(&(result.csfssd_attrstat_u.attributes.dtime),
	 &(file->dtime), sizeof(u32));
  result.csfssd_attrstat_u.attributes.uid = file->uid;
  result.csfssd_attrstat_u.attributes.gid = file->gid;
  result.csfssd_attrstat_u.attributes.size = file->size;
  result.csfssd_attrstat_u.attributes.link_count = file->link_count;
  result.csfssd_attrstat_u.attributes.gkid = file->gkid;
  memcpy(result.csfssd_attrstat_u.attributes.owner_lockbox, 
	 file->owner_lockbox, sizeof(char)*CSFSSD_KEY_LENGTH);
  memcpy(result.csfssd_attrstat_u.attributes.group_lockbox, 
	 file->group_lockbox, sizeof(char)*CSFSSD_KEY_LENGTH);
  memcpy(result.csfssd_attrstat_u.attributes.old_owner_lockbox, 
	 file->old_owner_lockbox, sizeof(char)*CSFSSD_KEY_LENGTH);
  memcpy(result.csfssd_attrstat_u.attributes.old_group_lockbox, 
	 file->old_group_lockbox, sizeof(char)*CSFSSD_KEY_LENGTH);
  memcpy(result.csfssd_attrstat_u.attributes.block_hash, 
	 file->block_hash, sizeof(csfssd_hash)*CSFSSD_HASHES);
  memcpy(&(result.csfssd_attrstat_u.attributes.aicf),
	 &(file->aicf), sizeof(csfssd_hash));
  result.csfssd_attrstat_u.attributes.generation = file->generation;
  result.csfssd_attrstat_u.attributes.magic = file->magic;
  result.csfssd_attrstat_u.attributes.inode_idx = file->inode_idx;
  memcpy(result.csfssd_attrstat_u.attributes.block_ptr, 
	 file->block_ptr, sizeof(csfssd_dp_t)*CSFSSD_DPTS);
  result.csfssd_attrstat_u.attributes.locked_by = file->locked_by;
  memcpy(&(result.csfssd_attrstat_u.attributes.locked_at), 
	 &(file->locked_at), sizeof(u32));
  memcpy(&(result.csfssd_attrstat_u.attributes.locked_duration),
	 &(file->locked_duration), sizeof(u32));
  
  
  result.status = CSFSSD_OK; 
  
  DEBUGP(DEBUG_CONCISE, ("csfssdproc_getattr_1_svc: exiting\n"));
  return(&result);
}

csfssd_attrstat * 
csfssdproc_setattr_1_svc(csfssd_sattrargs *argp, struct svc_req *rqstp)
{
  
  static csfssd_attrstat  result;
  inode_t *file;
  u32 uid;
  u16 duration;

  DEBUGP(DEBUG_CONCISE, ("csfssdproc_setattr_1_svc: entering\n"));
  /*
   * insert server code here
   */
  
  file = malloc(sizeof(inode_t));

  /* lookup inode */

  if(CSFSSD_readInode(csfssd, file, ((csfssd_fh_t*)(argp->file.data))->inode) < 0) 
    {
      DEBUGP(DEBUG_CONCISE,
	     ("csfssdproc_write_1_svc: can't read inode. exiting\n"));
      result.status = CSFSSDERR_NOENT;
      return(&result);
    }

  /* get uid */
  
  /* fake it for now */
  uid = 0; /*((struct authunix_params)(rqstp->rq_clntcred)).aup_uid;*/

  /* check that file lock is currently held by this user*/

  if(CSFSSD_lockFile(csfssd, file->inode_idx, 
		     uid, &duration) < 0)
    {
      DEBUGP(DEBUG_CONCISE,
       ("csfssdproc_setattr_1_svc: user does not hold lock on file. exiting\n"));
      result.status = CSFSSDERR_ACCES;
      return(&result);
    }

  file->mode = argp->attributes.mode;
  file->uid = argp->attributes.uid;
  file->gid = argp->attributes.gid;
  file->size = argp->attributes.size;
  memcpy(&(file->atime),&(argp->attributes.atime), sizeof(u32));
  memcpy(&(file->mtime),&(argp->attributes.mtime), sizeof(u32));
  file->gkid = argp->attributes.gkid;
  memcpy(file->owner_lockbox, argp->attributes.owner_lockbox, 
	 sizeof(char)*CSFSSD_KEY_LENGTH);
  memcpy(file->group_lockbox, argp->attributes.group_lockbox, 
	 sizeof(char)*CSFSSD_KEY_LENGTH);
  memcpy(&(file->aicf), &(argp->attributes.aicf), sizeof(csfssd_hash));


  
  
  result.status = CSFSSD_OK; 
  
  memcpy(&(result.csfssd_attrstat_u.attributes.type), 
	 &(file->mode), sizeof(csfssd_ftype));
  result.csfssd_attrstat_u.attributes.mode = file->mode;
  memcpy(&(result.csfssd_attrstat_u.attributes.atime),
	 &(file->atime), sizeof(u32));
  memcpy(&(result.csfssd_attrstat_u.attributes.mtime),
	 &(file->mtime), sizeof(u32));
  memcpy(&(result.csfssd_attrstat_u.attributes.ctime),
	 &(file->ctime), sizeof(u32));
  memcpy(&(result.csfssd_attrstat_u.attributes.dtime),
	 &(file->dtime), sizeof(u32));
  result.csfssd_attrstat_u.attributes.uid = file->uid;
  result.csfssd_attrstat_u.attributes.gid = file->gid;
  result.csfssd_attrstat_u.attributes.size = file->size;
  result.csfssd_attrstat_u.attributes.link_count = file->link_count;
  result.csfssd_attrstat_u.attributes.gkid = file->gkid;
  memcpy(result.csfssd_attrstat_u.attributes.owner_lockbox, 
	 file->owner_lockbox, sizeof(char)*CSFSSD_KEY_LENGTH);
  memcpy(result.csfssd_attrstat_u.attributes.group_lockbox, 
	 file->group_lockbox, sizeof(char)*CSFSSD_KEY_LENGTH);
  memcpy(result.csfssd_attrstat_u.attributes.old_owner_lockbox, 
	 file->old_owner_lockbox, sizeof(char)*CSFSSD_KEY_LENGTH);
  memcpy(result.csfssd_attrstat_u.attributes.old_group_lockbox, 
	 file->old_group_lockbox, sizeof(char)*CSFSSD_KEY_LENGTH);
  memcpy(result.csfssd_attrstat_u.attributes.block_hash, 
	 file->block_hash, sizeof(csfssd_hash)*CSFSSD_HASHES);
  memcpy(&(result.csfssd_attrstat_u.attributes.aicf),
	 &(file->aicf), sizeof(csfssd_hash));
  result.csfssd_attrstat_u.attributes.generation = file->generation;
  result.csfssd_attrstat_u.attributes.magic = file->magic;
  result.csfssd_attrstat_u.attributes.inode_idx = file->inode_idx;
  memcpy(result.csfssd_attrstat_u.attributes.block_ptr, 
	 file->block_ptr, sizeof(csfssd_dp_t)*CSFSSD_DPTS);
  result.csfssd_attrstat_u.attributes.locked_by = file->locked_by;
  memcpy(&(result.csfssd_attrstat_u.attributes.locked_at), 
	 &(file->locked_at), sizeof(u32));
  memcpy(&(result.csfssd_attrstat_u.attributes.locked_duration),
	 &(file->locked_duration), sizeof(u32));
  
  
  DEBUGP(DEBUG_CONCISE, ("csfssdproc_getattr_1_svc: exiting\n"));
  return(&result);
}

csfssd_lookupres * 
csfssdproc_lookup_1_svc(csfssd_lookupargs *argp, struct svc_req *rqstp)
{
  static csfssd_lookupres  result;
  csfssd_fh_t fh;
  inode_t *new_inode_ptr = malloc(sizeof(inode_t));

  
  DEBUGP(DEBUG_CONCISE, ("csfssdproc_lookup_1_svc: entering\n"));

  memset(&fh, 0, sizeof(csfssd_lookupres));

  /* Verify challenge response */
  /* args->chal */
  
  if (CSFSSD_readInode(csfssd, new_inode_ptr, argp->inode) < 0) {
    result.status = CSFSSDERR_NOENT;
    DEBUGP(DEBUG_CONCISE, 
	   ("csfssdproc_lookup_1_svc: can't read inode. exiting\n"));
    return(&result);
  }


  fh.inode = argp->inode;
  fh.gen = new_inode_ptr->generation;
  memcpy(&(result.csfssd_lookupres_u.file), &fh, sizeof(csfssd_fh_t));
  result.status = CSFSSD_OK; 
  
  /*
   * insert server code here
   */
  
  DEBUGP(DEBUG_CONCISE, ("csfssdproc_lookup_1_svc: exiting\n"));
  return(&result);
}

csfssd_readres * 
csfssdproc_read_1_svc(csfssd_readargs *argp, struct svc_req *rqstp)
{
  static csfssd_readres  result;
  u8 *data;
  int len;

  DEBUGP(DEBUG_CONCISE, ("csfssdproc_read_1_svc: entering\n"));
  /*
   * insert server code here
   */

  data = result.csfssd_readres_u.reply.data.data_val = malloc(argp->size);

  /* read the data */
  if((len = CSFSSD_readData(csfssd, ((csfssd_fh_t*)(argp->file.data))->inode,
			    argp->offset, 
			    argp->size, data)) > 0)
    {
      result.status = CSFSSD_OK;
      result.csfssd_readres_u.reply.data.data_len = len;
    }
  else
    {
      DEBUGP(DEBUG_CONCISE,
	     ("csfssdproc_read_1_svc: error reading file\n"));
      result.status = CSFSSDERR_IO;
    }


  DEBUGP(DEBUG_CONCISE, ("csfssdproc_read_1_svc: exiting\n"));
  return(&result);
}

csfssd_statfsres * 
csfssdproc_write_1_svc(csfssd_writeargs *argp, struct svc_req *rqstp)
{
  static csfssd_statfsres  result;
  u32 uid;
  u16 duration;

  DEBUGP(DEBUG_CONCISE, ("csfssdproc_write_1_svc: entering\n"));

  /*
   * insert server code here
   */


  /* get uid */
  
  /* fake it for now */
  uid = 0;/*((struct authunix_params)(rqstp->rq_clntcred)).aup_uid;*/

  /* check that file lock is currently held by this user*/

  if(CSFSSD_lockFile(csfssd, ((csfssd_fh_t*)(argp->file.data))->inode, uid, &duration) < 0)
    {
      DEBUGP(DEBUG_CONCISE,
       ("csfssdproc_write_1_svc: user does not hold lock on file. exiting\n"));
      result.status = CSFSSDERR_ACCES;
      return(&result);
    }

  /* write the data */
  if((CSFSSD_writeData(csfssd, ((csfssd_fh_t*)(argp->file.data))->inode, 
		       argp->offset, 
		       argp->size, argp->data.data_val)) > 0)
    {
      result.status = CSFSSD_OK;
      
    }
  else
    {
      DEBUGP(DEBUG_CONCISE,
	     ("csfssdproc_write_1_svc: error writing file\n"));
      result.status = CSFSSDERR_IO;
    }

  
  DEBUGP(DEBUG_CONCISE, ("csfssdproc_write_1_svc: exiting\n"));
  return(&result);
}

csfssd_lockres * 
csfssdproc_lock_1_svc(csfssd_lockargs *argp, struct svc_req *rqstp)
{

  static csfssd_lockres  result;


  DEBUGP(DEBUG_CONCISE,("csfssdproc_lock_1_svc: entering\n"));
  /*
   * insert server code here
   */
  
  /* Lock File, check if successful, set result accordingly*/

  if(CSFSSD_lockFile(csfssd,
		     ((csfssd_fh_t*)(argp->file.data))->inode, 
		     argp->uid,
		     (u16 *)&(argp->duration)) < 0)
    {
      DEBUGP(DEBUG_CONCISE, 
	     ("csfssdproc_lock_1_svc: can't lock file. exiting.\n"));
      result.status = CSFSSDERR_LOCK;
      return(&result);
    }

  result.status = CSFSSD_OK;
  DEBUGP(DEBUG_CONCISE,("csfssdproc_lock_1_svc: exiting\n"));

  return(&result);
}

csfssdstat * 
csfssdproc_unlock_1_svc(csfssd_unlockargs *argp, struct svc_req *rqstp)
{

  static csfssdstat  result;

  DEBUGP(DEBUG_CONCISE,("csfssdproc_unlock_1_svc: entering\n"));
  /*
   * insert server code here
   */
  


  /* Unlock File, check if successful, set result accordingly*/

  if(CSFSSD_unlockFile(csfssd,((csfssd_fh_t*)(argp->file.data))->inode, argp->uid) < 0)
    {
      DEBUGP(DEBUG_CONCISE, 
	     ("csfssdproc_unlock_1_svc: can't unlock file. exiting.\n"));
      result = CSFSSDERR_LOCK;
      return(&result);
    }

  result = CSFSSD_OK;
  DEBUGP(DEBUG_CONCISE,("csfssdproc_unlock_1_svc: exiting\n"));

  return(&result);
}

csfssd_readdpres * 
csfssdproc_read_dp_block_1_svc(csfssd_readdpargs *argp, struct svc_req *rqstp)
{

  static csfssd_readdpres  result;
  int i;

  DEBUGP(DEBUG_CONCISE, ("csfssdproc_read_dp_block_1_svc: entering\n"));
  /*
   * insert server code here
   */
  

  /* read each dp block */
  for(i=0; i<argp->dp_nums.dp_nums_len; i++)
    {

      CSFSSD_readDPBlock(csfssd,
			 ((csfssd_fh_t*)(argp->file.data))->inode, 
			 argp->dp_nums.dp_nums_val[i],
			 (u8 *)result.dp.dp_val[i]); 
    }
  
  result.dp.dp_len = argp->dp_nums.dp_nums_len;

  DEBUGP(DEBUG_CONCISE, ("csfssdproc_read_dp_block_1_svc: exiting\n"));
  return(&result);
}

csfssd_statfsres * 
csfssdproc_write_dp_block_1_svc(csfssd_writedpargs *argp, struct svc_req *rqstp)
{

  static csfssd_statfsres  result;
  u32 uid;
  u16 duration;
  int i;

  DEBUGP(DEBUG_CONCISE, ("csfssdproc_write_dp_block_1_svc: entering\n"));
  /*
   * insert server code here
   */
  
  
  /* get uid */
  
  /* fake it for now */
  uid = 0; /*((struct authunix_params)(rqstp->rq_clntcred)).aup_uid; */

  /* check that file lock is currently held by this user*/

  if(CSFSSD_lockFile(csfssd, ((csfssd_fh_t*)(argp->file.data))->inode, uid, &duration) < 0)
    {
      DEBUGP(DEBUG_CONCISE,
       ("csfssdproc_write_dp_block_1_svc: user does not hold lock on file. exiting\n"));
      result.status = CSFSSDERR_ACCES;
      return(&result);
    }

  /* write the blocks */
  for(i=0; i<argp->dp_nums.dp_nums_len; i++)
    {
      CSFSSD_writeDPBlock(csfssd,
			  ((csfssd_fh_t*)(argp->file.data))->inode,
			  argp->dp_nums.dp_nums_val[i],
			  argp->dp.dp_val[i]);
    }
  result.status = CSFSSD_OK;

  DEBUGP(DEBUG_CONCISE, ("csfssdproc_write_dp_block_1_svc: exiting\n"));
  return(&result);
}

csfssd_createres * 
csfssdproc_create_1_svc(csfssd_createargs *argp, struct svc_req *svrq)
{
  static csfssd_createres  result;
  u32 new_inode_idx; 

  DEBUGP(DEBUG_CONCISE, ("csfssdproc_create_1_svc: entering\n"));

  /*
   * insert server code here
   */

  if(CSFSSD_allocInode(csfssd, &new_inode_idx, argp->dir_inode_idx) < 0)
    {
      DEBUGP(DEBUG_CONCISE, ("csfssdproc_create_1_svc: can't alloc inode. exiting.\n"));
      result.status = CSFSSDERR_IO;
      return(&result);
    }
  
  result.csfssd_createres_u.inode_idx = new_inode_idx;
  result.status = CSFSSD_OK;
  DEBUGP(DEBUG_CONCISE, ("csfssdproc_create_1_svc: exiting\n"));
  return(&result);
}

csfssd_linkres * 
csfssdproc_link_1_svc(csfssd_linkargs *argp, struct svc_req *rqstp)
{
  static csfssd_linkres  result;
  inode_t *file;
  u32 uid;
  u16 duration;

  DEBUGP(DEBUG_CONCISE, ("csfssdproc_link_1_svc: entering\n"));

  /*
   * insert server code here
   */
  
  file = malloc(sizeof(inode_t));

  /* lookup inode */

  if(CSFSSD_readInode(csfssd, file, argp->inode_idx) < 0) 
    {
      DEBUGP(DEBUG_CONCISE,
	     ("csfssdproc_link_1_svc: can't read inode. exiting\n"));
      result.status = CSFSSDERR_NOENT;
      return(&result);
    }
  
  /* get uid */
  
  /* fake it for now */
  uid = 0;/*((struct authunix_params)(rqstp->rq_clntcred)).aup_uid;*/

  /* check that file lock is currently held by this user*/

  if(CSFSSD_lockFile(csfssd, argp->inode_idx, uid, &duration) < 0)
    {
      DEBUGP(DEBUG_CONCISE,
       ("csfssdproc_link_1_svc: user does not hold lock on file. exiting\n"));
      result.status = CSFSSDERR_ACCES;
      return(&result);
    }

  file->link_count++;

  /* write inode back to disk */

  if(CSFSSD_writeInode(csfssd, file, file->inode_idx) < 0)
    {
      DEBUGP(DEBUG_CONCISE, ("csfssdproc_link_1_svc: error writing inode. exiting\n"));
      result.status = CSFSSDERR_IO;
      return(&result);
    }

  result.status = CSFSSD_OK;
  result.csfssd_linkres_u.link_count = file->link_count;

  free(file);
  DEBUGP(DEBUG_CONCISE, ("csfssdproc_link_1_svc: exiting\n"));
  return(&result);
}

csfssd_unlinkres * 
csfssdproc_unlink_1_svc(csfssd_unlinkargs *argp, struct svc_req *rqstp)
{
  static csfssd_unlinkres  result;
  inode_t *file;
  u32 uid;
  u16 duration;

  DEBUGP(DEBUG_CONCISE, ("csfssdproc_unlink_1_svc: entering\n"));

  /*
   * insert server code here
   */
  
  file = malloc(sizeof(inode_t));

  /* lookup inode */

  if(CSFSSD_readInode(csfssd, file, argp->inode_idx) < 0) 
    {
      DEBUGP(DEBUG_CONCISE,
	     ("csfssdproc_unlink_1_svc: can't read inode. exiting\n"));
      result.status = CSFSSDERR_NOENT;
      return(&result);
    }
  
  /* get uid */
  
  /* Fake it for now */
  uid = 0;/*((struct authunix_params)(rqstp->rq_clntcred)).aup_uid;*/

  /* check that file lock is currently held by this user*/

  if(CSFSSD_lockFile(csfssd, argp->inode_idx, uid, &duration) < 0)
    {
      DEBUGP(DEBUG_CONCISE,
       ("csfssdproc_unlink_1_svc: user does not hold lock on file. exiting\n"));
      result.status = CSFSSDERR_ACCES;
      return(&result);
    }

  file->link_count--;

  /* write inode back to disk */

  if(CSFSSD_writeInode(csfssd, file, file->inode_idx) < 0)
    {
      DEBUGP(DEBUG_CONCISE, ("csfssdproc_unlink_1_svc: error writing inode. exiting\n"));
      result.status = CSFSSDERR_IO;
      return(&result);
    }

  result.status = CSFSSD_OK;
  result.csfssd_unlinkres_u.link_count = file->link_count;

  free(file);
  DEBUGP(DEBUG_CONCISE, ("csfssdproc_unlink_1_svc: exiting\n"));
  return(&result);
}

csfssd_statfsres * 
csfssdproc_statfs_1_svc(csfssd_fh *argp, struct svc_req *rqstp)
{

  static csfssd_statfsres  result;

  DEBUGP(DEBUG_CONCISE, ("csfssdproc_statfs_1_svc: entering\n"));

  /*
   * insert server code here
   */

 if(CSFSSD_statfs(csfssd,
		  (u16 *)&(result.csfssd_statfsres_u.reply.bsize), 
		  &(result.csfssd_statfsres_u.reply.blocks), 
		  &(result.csfssd_statfsres_u.reply.bfree),
		  &(result.csfssd_statfsres_u.reply.bavail)) < 0)
   {
     result.status = CSFSSDERR_IO;
   }

  
  DEBUGP(DEBUG_CONCISE, ("csfssdproc_statfs_1_svc: exiting\n"));
  return(&result);
}

void usage(char *progname) {
  printf("Usage: %s <disk pathname>\n\n", progname);
  printf("Example: mkfs /tmp/disk; %s /tmp/disk\n", progname);
  exit(1);
}

int
main(int argc, char **argv)
{
  register SVCXPRT *transp;
 

  debuglevel = DEBUG_VERBOSE;

  /* Load disk */
  
  if (argc != 2) 
    usage(argv[0]);

  csfssd = (csfssd_t *)malloc(sizeof(csfssd_t));

  if (CSFSSD_mount(csfssd, argv[1], 0) < 0)
    {
      DEBUGP(DEBUG_CONCISE, ("main(): CSFSD_mount failed\n"));
      exit(1);
    }

 
  pmap_unset(CSFSSD_PROGRAM, CSFSSD_VERSION);
  
  transp = svcudp_create(RPC_ANYSOCK);
  if (transp == NULL) {
    fprintf(stderr, "cannot create udp service.");
    exit(1);
  }
  if (!svc_register(transp, CSFSSD_PROGRAM, CSFSSD_VERSION, csfssd_program_1, IPPROTO_UDP)) {
    fprintf(stderr, "unable to register (CSFSSD_PROGRAM, CSFSSD_VERSION, udp).");
    exit(1);
  }
  
  transp = svctcp_create(RPC_ANYSOCK, 0, 0);
  if (transp == NULL) {
    fprintf(stderr, "cannot create tcp service.");
    exit(1);
  }
  if (!svc_register(transp, CSFSSD_PROGRAM, CSFSSD_VERSION, csfssd_program_1, IPPROTO_TCP)) {
    fprintf(stderr, "unable to register (CSFSSD_PROGRAM, CSFSSD_VERSION, tcp).");
    exit(1);
  }
  
  svc_run();
  fprintf(stderr, "svc_run returned");
  exit(1);
  /* NOTREACHED */
}
