#ifndef __SFSBC_H__
#define __SFSBC_H__ 1

#define SECTOR_SIZE 512

#define BUF_INVAL  1
#define BUF_DONE   2
#define BUF_DELWRI 4

struct buf {
  u_int      flags;
  mutex_t  lock;
  HASH_ENTRY(buf)  hash;
  TAILQ_ENTRY(buf) free;
  u_int      offset;
  u_int      size;
  char       *data;
};

void bc_init(char *name);
struct buf *bread(u_int secno, u_int size);
struct buf *breadn(u_int secno, u_int size, u_int nblocks);
int bwrite(struct buf *bp);
void brelse(struct buf *bp);
struct buf *getblk(u_int secno, u_int size);

/* Invalidate buffer contents but do not release */
void binval(struct buf *bp);

#define bdwrite bwrite
#define bawrite bwrite

#endif
