#ifndef __UAGENT_H__
#define __UAGNET_H__

#include "misc/ipc.h"
#include "cd/csfscd.h"

#define MAX_LISTEN_NAME 100
#define LISTEN_PATH "/tmp/csfsua."

/* Error conditions the uagent will respond to client */
typedef enum csfsstat {
  CSFS_OK = 0,
  CSFSERR_PERM = 1,
  CSFSERR_NOENT = 2,
  CSFSERR_IO = 5,
  CSFSERR_NXIO = 6,
  CSFSERR_ACCESS = 13,
  CSFSERR_EXIST = 17,
  CSFSERR_NODEV = 19,
  CSFSERR_NOTDIR = 20,
  CSFSERR_ISDIR = 21,
  CSFSERR_FBIG = 27,
  CSFSERR_NOSPC = 28,
  CSFSERR_ROFS = 30,
  CSFSERR_NAMETOOLONG = 63,
  CSFSERR_NOTEMPTY = 66,
  CSFSERR_DQUOT = 69,
  CSFSERR_STALE = 70,
  CSFSERR_WFLUSH = 99
} csfsstat_t;


/* Structure of request/response between uagent/client */
typedef struct csfsua_s {
  u32 opcode;   /* Type of request/response */
  u32 seq;      /* Sequence number */
  u32 datalen;
  u8 *data;
} csfsua_t;

#endif
