/* $Id: machdep.c,v 1.1 1998/10/21 18:33:43 fubobb Exp $ */

#include "private.h"

void thread_md_begin (void);
mdreg_t thread_md_getsp (void);

mdreg_t
thread_md_stackcheck (void)
{
  mdreg_t sp;

  sp = thread_md_getsp ();
  if (sp - 128 < (mdreg_t) thread_current->t_stack)
    thread_panic ("stack overflow\n");
  if (sp > (mdreg_t) thread_current->t_stack + thread_stack_size)
    thread_panic ("stack underflow\n");

  return sp;
}

void
thread_md_init (tcb *t, void (*fn) (void *), void *arg)
{
  mdreg_t *sp;

  sp = (void *) (t->t_stack + thread_stack_size) - 128;

  sp[0] = (mdreg_t) thread_md_begin;
  sp[1] = (mdreg_t) t;
  sp[2] = (mdreg_t) fn;
  sp[3] = (mdreg_t) arg;

  t->t_md.md_sp = (mdreg_t) sp;
}
