/* $Id: machdep.c,v 1.1 1998/10/21 18:33:51 fubobb Exp $ */

#include "private.h"

mdreg_t thread_md_getesp (void);

mdreg_t
thread_md_stackcheck (void)
{
  mdreg_t esp;

  esp = thread_md_getesp ();
  if (esp - 16 < (mdreg_t) thread_current->t_stack)
    thread_panic ("stack overflow\n");
  if (esp > (mdreg_t) thread_current->t_stack + thread_stack_size)
    thread_panic ("stack underflow\n");

  return esp;
}

void
thread_md_init (tcb *t, void (*fn) (void *), void *arg)
{
  mdreg_t *sp;

  sp = (void *) (t->t_stack + thread_stack_size);

  /* Set up a callframe to thread_begin */
  *--sp = (mdreg_t) arg;
  *--sp = (mdreg_t) fn;
  *--sp = (mdreg_t) t;
  *--sp = 0;  /* No return address */

  /* Now set up saved registers for switch.S */
  *--sp = (mdreg_t) thread_begin;  /* return address */
  *--sp = 0;   /* ebp */
  *--sp = 0;   /* ebx */
  *--sp = 0;   /* esi */
  *--sp = 0;   /* edi */

  t->t_md.md_esp = (mdreg_t) sp;
}
