/* $Id: machdep.c,v 1.1 1998/10/21 18:33:59 fubobb Exp $ */

#include "private.h"

void thread_md_begin (void);
mdreg_t thread_md_getsp (void);

mdreg_t
thread_md_stackcheck (void)
{
  mdreg_t sp;

  sp = thread_md_getsp ();
  if (sp - 64 < (mdreg_t) thread_current->t_stack)
    thread_panic ("stack overflow\n");
  if (sp > (mdreg_t) thread_current->t_stack + thread_stack_size)
    thread_panic ("stack underflow\n");

  return sp;
}

void
thread_md_init (tcb *t, void (*fn) (void *), void *arg)
{
  mdreg_t *sp;

  sp = (void *) (t->t_stack + thread_stack_size - 104);

  sp[8] = (mdreg_t) t;
  sp[9] = (mdreg_t) fn;
  sp[10] = (mdreg_t) arg;
  sp[11] = (mdreg_t) thread_begin;

  t->t_md.md_fp = (mdreg_t) sp;
  t->t_md.md_ra = (mdreg_t) thread_md_begin - 8;
}
