/* $Id: malloc.h,v 1.1 1998/10/21 18:33:14 fubobb Exp $ */

#ifndef _UPT_MALLOC_H_
#define _UPT_MALLOC_H_ 1

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include <stdlib.h>
#include <sys/types.h>

#ifndef NULL
#define NULL 0
#endif

extern void *xrealloc (void *, size_t);
extern void xfree (void *);
extern void *xmalloc (size_t);

extern void (*xmalloc_handler) (void);

/* Unsupported stuff we don't want called by accident */
#define valloc dont_call_valloc
#define calloc dont_call_calloc
#define cfree dont_call_cfree

#ifdef DMALLOC

extern void *realloc_r (void *, size_t);
extern void free_r (void *);
extern void *malloc_r (size_t);

void *threadsafe_realloc_leap (char *, int, void *, size_t);
void *threadsafe_xrealloc_leap (char *, int, void *, size_t);

#define DMALLOC_FUNC_CHECK
#include <dmalloc.h>

#undef free
#undef malloc
#undef realloc
#undef xmalloc
#undef xfree
#undef xrealloc

#define realloc(p, s) threadsafe_realloc_leap (__FILE__, __LINE__, p, s)
#define malloc(s) realloc (NULL, s)
#define free(p) realloc (p, 0)

#define xrealloc(p, s) threadsafe_xrealloc_leap (__FILE__, __LINE__, p, s)
#define xmalloc(s) realloc (NULL, s)
#define xfree(p) realloc (p, 0)

#define memmove(to, from, len) _dmalloc_bcopy((const char *) from, \
					      (char *) to, len)
#undef memcpy
#define memcpy(to, from, len) _dmalloc_memcpy((char *) to, \
					      (const char *) from, len)

#endif /* DMALLOC */

#ifdef __cplusplus
}
#ifdef DMALLOC
struct dmalloc_t {};
extern struct dmalloc_t dmalloc;
void *operator new (size_t, dmalloc_t, char *, int);
void *operator new[] (size_t, dmalloc_t, char *, int);
#define new new(dmalloc, __FILE__, __LINE__)
#endif /* DMALLOC */
#endif /* __cplusplus */

#endif /* !_UPT_MALLOC_H_ */
