/* $Id: syscall.h,v 1.1 1998/10/21 18:33:34 fubobb Exp $ */

#ifndef _UPT_SYSCALL_H_
#define _UPT_SYSCALL_H_ 1

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/* We need include files for off_t and fd_set */
#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>

struct iovec;
struct msghdr;
struct sockaddr;
struct msghdr;

ssize_t upt_writev (int, const struct iovec *, int);
ssize_t upt_readv (int, const struct iovec *iov, int iovcnt);
ssize_t upt_read (int, void *buf, size_t nbites);
ssize_t upt_write (int, const void *, size_t);
ssize_t upt_recvmsg (int, struct msghdr *, int);
ssize_t upt_sendmsg (int, const struct msghdr *, int);
int upt_accept (int, struct sockaddr *, int *);
int upt_connect (int, const struct sockaddr *, int);
off_t upt_lseek (int, off_t, int);
int upt_close (int);
int upt_select (int, fd_set *, fd_set *, fd_set *, struct timeval *);

#if 0   /* XXX temporary measure */
#ifndef UPT_INTERNAL

#define writev upt_writev
#define readv upt_readv
#define read upt_read
#define write upt_write
#define recvmsg upt_recvmsg
#define sendmsg upt_sendmsg
#define accept upt_accept
#define connect upt_connect
#define lseek upt_lseek
#define close upt_close
#define select upt_select

#endif /* !UPT_INTERNAL */
#endif

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* !_UPT_SYSCALL_H_ */
