/* Borrowed from dm's SFS */
/* $Id: */

#include "../sfsmisc.h"
#include "../crypto/rw.h"
#include "../crypto/randoms.h"
#include "../crypto/misc.h"

/* #include "async/misc.h" */

#define   CSFS_KEY_PRIV "priv"
#define   CSFS_KEY_PUB  "pub"

char *progname;

static void
usage (void)
{
  printf ("%s keyfile\n", progname);
  exit (1);
}

static void
dokeygen (char *skfile)
{
  char *home;
  char *path;
  RandomState rs;
  rw_priv *sk;
  rw_pub psk;
  char *priv;
  char *pub;

  home = getenv ("HOME");
  if (!home)
    exit(1);
    /*    fatal ("can't find your home directory");*/

  path = xmalloc(strlen(USER_RANDOM_SEED) + strlen(home)+1);
  sprintf (path, "%s/%s", home, USER_RANDOM_SEED);
  random_initialize (&rs, path);
  random_acquire_environmental_noise (&rs);
  rw_set_verbose (1);
  sk = rw_keygen (&rs, 1024);

  priv = xmalloc(strlen(skfile) + 1 + sizeof(CSFS_KEY_PRIV));
  strcpy (priv, skfile);
  strcat (priv, "." CSFS_KEY_PRIV);

  pub = xmalloc(strlen(skfile) + 1 + sizeof(CSFS_KEY_PUB));
  strcpy (pub, skfile);
  strcat (pub, "." CSFS_KEY_PUB);

  rw_priv2file (priv, sk);
  rw_priv2pub (&psk, sk);
  rw_pub2file (pub, &psk);

  rw_freepriv (sk);
  random_save (&rs, path);
}

int
main (int argc, char **argv)
{

  progname = argv[0];

  if (argc != 2)
    usage ();

  dokeygen (argv[1]);
  
  return (0);
}


